/*!
* Dynamsoft Mobile Web Capture JavaScript Library
* @product Dynamsoft Mobile Web Capture JS Edition Bundle
* @website http://www.dynamsoft.com
* @copyright Copyright 2025, Dynamsoft Corporation
* @author Dynamsoft
* @version 3.1.0
* @fileoverview Mobile Web Capture (MWC) is an SDK for scanning multi-page documents, enhancing Dynamsoft Document Scanner (DDS) with multi-document management, annotation, and uploading.
* More info on MWC JS: https://www.dynamsoft.com/capture-vision/docs/web/programming/javascript/
*/
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports,require("dynamsoft-core"),require("dynamsoft-license"),require("dynamsoft-capture-vision-router"),require("dynamsoft-camera-enhancer"),require("dynamsoft-document-normalizer"),require("dynamsoft-utility"),require("dynamsoft-document-viewer"),require("dynamsoft-document-scanner")):"function"==typeof define&&define.amd?define(["exports","dynamsoft-core","dynamsoft-license","dynamsoft-capture-vision-router","dynamsoft-camera-enhancer","dynamsoft-document-normalizer","dynamsoft-utility","dynamsoft-document-viewer","dynamsoft-document-scanner"],n):n((e="undefined"!=typeof globalThis?globalThis:e||self).Dynamsoft=e.Dynamsoft||{},e.Dynamsoft.Core,e.Dynamsoft.License,e.Dynamsoft.CVR,e.Dynamsoft.DCE,e.Dynamsoft.DDN,e.Dynamsoft.Utility,e.Dynamsoft,e.Dynamsoft.DDS)}(this,(function(e,n,t,i,a,o,l,s,c){"use strict";function d(e){var n=Object.create(null);return e&&Object.keys(e).forEach((function(t){if("default"!==t){var i=Object.getOwnPropertyDescriptor(e,t);Object.defineProperty(n,t,i.get?i:{enumerable:!0,get:function(){return e[t]}})}})),n.default=e,Object.freeze(n)}var r=d(n),h=d(t),m=d(i),u=d(a),p=d(o),v=d(l),w=d(s),g=d(c);const f={cameraCapture:'\n  <svg id="camera-capture" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="28" height="24" viewBox="0 0 28 24">\n    <defs>\n      <clipPath id="cameraCaptureclip-path">\n        <rect id="Rectangle_2738" data-name="Rectangle 2738" width="28" height="24" fill="#fff"/>\n      </clipPath>\n    </defs>\n    <g id="Group_529" data-name="Group 529" clip-path="url(#cameraCaptureclip-path)">\n      <path id="Path_1455" data-name="Path 1455" d="M24.37,4.174H21.287a1.672,1.672,0,0,1-1.224-.635L18.387,1.066A2.726,2.726,0,0,0,16.356,0H11.615A2.725,2.725,0,0,0,9.6,1.09L7.5,4.174l-3.927,0A3.978,3.978,0,0,0,0,8.206V20.348A3.645,3.645,0,0,0,3.63,24H24.37A3.645,3.645,0,0,0,28,20.348V8.212a3.99,3.99,0,0,0-3.63-4.038m2.593,16.174a2.6,2.6,0,0,1-2.593,2.609H3.63a2.6,2.6,0,0,1-2.592-2.609V8.2A2.935,2.935,0,0,1,3.63,5.218H7.778a.521.521,0,0,0,.429-.228L10.436,1.7a1.663,1.663,0,0,1,1.208-.657h4.683a1.665,1.665,0,0,1,1.221.635l1.676,2.474a2.735,2.735,0,0,0,2.033,1.066l3.06,0a2.946,2.946,0,0,1,2.646,2.991Z" fill="#fff"/>\n      <path id="Path_1456" data-name="Path 1456" d="M14,8.348a5.739,5.739,0,1,0,5.7,5.739A5.729,5.729,0,0,0,14,8.348m0,10.435a4.7,4.7,0,1,1,4.667-4.7A4.687,4.687,0,0,1,14,18.783" fill="#fff"/>\n    </g>\n  </svg>\n  ',galleryImport:'\n  <svg id="gallery-import" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n    <defs>\n      <clipPath id="galleryImportclip-path">\n        <rect id="Rectangle_2739" data-name="Rectangle 2739" width="24" height="24" fill="#fff"/>\n      </clipPath>\n    </defs>\n    <g id="Group_531" data-name="Group 531" clip-path="url(#galleryImportclip-path)">\n      <path id="Path_1457" data-name="Path 1457" d="M19.7,18.1V1.6A1.6,1.6,0,0,0,18.1,0H1.6A1.6,1.6,0,0,0,0,1.6V18.1a1.6,1.6,0,0,0,1.6,1.6H18.1a1.6,1.6,0,0,0,1.6-1.6M1.6,1H18.1a.6.6,0,0,1,.6.6V15.4H16.236L13.472,8.489c-.258-.659-.695-.74-.872-.745a1.019,1.019,0,0,0-.911.7L9.722,12.768l-1.5-1.8A1.236,1.236,0,0,0,7.1,10.427a1.211,1.211,0,0,0-1,.659L3.516,15.4H1V1.6A.6.6,0,0,1,1.6,1M15.159,15.4H4.682l2.3-3.842a.236.236,0,0,1,.194-.134.273.273,0,0,1,.241.142L9.464,14.02a.5.5,0,0,0,.839-.113L12.57,8.924ZM1,18.1V16.4H18.7v1.7a.6.6,0,0,1-.6.6H1.6a.6.6,0,0,1-.6-.6" fill="#fff"/>\n      <path id="Path_1458" data-name="Path 1458" d="M22.55,6.571l-1.1-.1a.5.5,0,0,0-.091,1l1.1.1a.6.6,0,0,1,.541.65l-1.3,14.24a.6.6,0,0,1-.653.54L5.714,21.6a.5.5,0,0,0-.09,1l15.332,1.4A1.414,1.414,0,0,0,21.1,24a1.606,1.606,0,0,0,1.593-1.45l1.3-14.243A1.606,1.606,0,0,0,22.55,6.571" fill="#fff"/>\n      <path id="Path_1459" data-name="Path 1459" d="M5.449,7.6A2.15,2.15,0,1,0,3.3,5.45,2.152,2.152,0,0,0,5.449,7.6m0-3.3A1.15,1.15,0,1,1,4.3,5.45,1.151,1.151,0,0,1,5.449,4.3" fill="#fff"/>\n    </g>\n  </svg>\n  ',fileOperations:'\n  <svg id="file-operations" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n    <defs>\n      <clipPath id="fileOpclip-path">\n        <rect id="Rectangle_2763" data-name="Rectangle 2763" width="24" height="24" fill="#fff"/>\n      </clipPath>\n    </defs>\n    <g id="Group_558" data-name="Group 558" clip-path="url(#fileOpclip-path)">\n      <path id="Path_1490" data-name="Path 1490" d="M13.5,19H9.949A3.494,3.494,0,0,0,6.5,16H1v-.5a.5.5,0,0,0-1,0v8a.5.5,0,0,0,1,0V23H16.5a.5.5,0,0,0,.5-.5A3.5,3.5,0,0,0,13.5,19M1,22V17H6.5a2.5,2.5,0,0,1,2.449,2H5.5a.5.5,0,0,0,0,1h8a2.5,2.5,0,0,1,2.45,2Z" fill="#fff"/>\n      <path id="Path_1491" data-name="Path 1491" d="M23.56,3.854,20.146.44A1.492,1.492,0,0,0,19.085,0H8.5A1.5,1.5,0,0,0,7,1.5v12a.5.5,0,0,0,1,0V1.5A.5.5,0,0,1,8.5,1H19.085a.5.5,0,0,1,.354.147l3.414,3.414A.5.5,0,0,1,23,4.915V19.5a.5.5,0,0,1-.5.5H19a.5.5,0,1,0,0,1h3.5A1.5,1.5,0,0,0,24,19.5V4.915a1.491,1.491,0,0,0-.439-1.061" fill="#fff"/>\n    </g>\n  </svg>  \n  ',copyTo:'\n  <svg id="copy-to" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="20" height="24" viewBox="0 0 20 24">\n    <defs>\n      <clipPath id="copyToclip-path">\n        <rect id="Rectangle_2765" data-name="Rectangle 2765" width="20" height="24" fill="#fff"/>\n      </clipPath>\n    </defs>\n    <g id="Group_562" data-name="Group 562" clip-path="url(#copyToclip-path)">\n      <path id="Path_1504" data-name="Path 1504" d="M19.561,3.854,16.146.439A1.49,1.49,0,0,0,15.086,0H4.5A1.5,1.5,0,0,0,3,1.5V3H1.5A1.5,1.5,0,0,0,0,4.5v18A1.5,1.5,0,0,0,1.5,24h14A1.5,1.5,0,0,0,17,22.5V21h1.5A1.5,1.5,0,0,0,20,19.5V4.914a1.49,1.49,0,0,0-.439-1.06M16,22.5a.5.5,0,0,1-.5.5H1.5a.5.5,0,0,1-.5-.5V4.5A.5.5,0,0,1,1.5,4H3V19.5A1.5,1.5,0,0,0,4.5,21H16Zm3-3a.5.5,0,0,1-.5.5H4.5a.5.5,0,0,1-.5-.5V1.5A.5.5,0,0,1,4.5,1H15.086a.5.5,0,0,1,.353.146l3.415,3.415A.5.5,0,0,1,19,4.914Z" fill="#fff"/>\n      <path id="Path_1505" data-name="Path 1505" d="M14.842,10.141l0-.007L12.6,7.885a.5.5,0,0,0-.719.695l.012.012,1.4,1.4h-4.8a.5.5,0,0,0,0,1h4.793l-1.4,1.4a.5.5,0,1,0,.707.707l2.249-2.25a.5.5,0,0,0,.109-.545.53.53,0,0,0-.109-.163" fill="#fff"/>\n    </g>\n  </svg>\n  ',moveTo:'\n  <svg id="move-to" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n    <defs>\n      <clipPath id="moveToclip-path">\n        <rect id="Rectangle_2764" data-name="Rectangle 2764" width="24" height="24" fill="#fff"/>\n      </clipPath>\n    </defs>\n    <g id="Group_560" data-name="Group 560" clip-path="url(#moveToclip-path)">\n      <path id="Path_1492" data-name="Path 1492" d="M13.71,12.528l-1.147,1.146a.5.5,0,0,0,.708.708l2-2a.5.5,0,0,0,0-.708l-2-2a.5.5,0,0,0-.708.708l1.147,1.146H5.917c-.552,0-1.1,1,0,1Z" fill="#fff"/>\n      <path id="Path_1493" data-name="Path 1493" d="M.5,13.241a.5.5,0,0,0-.5.5v1.87a1.6,1.6,0,0,0,.01.17A.474.474,0,0,0,.5,16.2a.375.375,0,0,0,.067,0A.522.522,0,0,0,1,15.611v-1.87a.5.5,0,0,0-.5-.5" fill="#fff"/>\n      <path id="Path_1494" data-name="Path 1494" d="M.5,9.282a.5.5,0,0,0-.5.5v1.979a.5.5,0,0,0,1,0V9.782a.5.5,0,0,0-.5-.5" fill="#fff"/>\n      <path id="Path_1495" data-name="Path 1495" d="M12.385,3.258a.4.4,0,0,1,.115.277v.958a.5.5,0,0,0,1,0V3.535a1.389,1.389,0,0,0-.407-.983l-.229-.229a.5.5,0,0,0-.707.707Z" fill="#fff"/>\n      <path id="Path_1496" data-name="Path 1496" d="M9.415,1h.549a.4.4,0,0,1,.276.113l.517.517a.5.5,0,0,0,.719-.695L11.464.923,10.946.405A1.386,1.386,0,0,0,9.964,0H9.415a.5.5,0,0,0,0,1" fill="#fff"/>\n      <path id="Path_1497" data-name="Path 1497" d="M.5,5.323a.5.5,0,0,0-.5.5V7.8a.5.5,0,0,0,1,0V5.823a.5.5,0,0,0-.5-.5" fill="#fff"/>\n      <path id="Path_1498" data-name="Path 1498" d="M8.021,16H6.042a.5.5,0,0,0,0,1H8.021a.5.5,0,0,0,0-1" fill="#fff"/>\n      <path id="Path_1499" data-name="Path 1499" d="M7.436,1a.5.5,0,0,0,0-1H5.457a.5.5,0,0,0,0,1Z" fill="#fff"/>\n      <path id="Path_1500" data-name="Path 1500" d="M.5,1.364a.5.5,0,0,0-.5.5V3.843a.5.5,0,0,0,1,0V1.864a.5.5,0,0,0-.5-.5" fill="#fff"/>\n      <path id="Path_1501" data-name="Path 1501" d="M4.062,16H2.082a.5.5,0,0,0,0,1h1.98a.5.5,0,0,0,0-1" fill="#fff"/>\n      <path id="Path_1502" data-name="Path 1502" d="M3.977.5a.5.5,0,0,0-.5-.5H1.5a.5.5,0,0,0,0,1H3.477a.5.5,0,0,0,.5-.5" fill="#fff"/>\n      <path id="Path_1503" data-name="Path 1503" d="M23.594,9.552,21.447,7.405A1.385,1.385,0,0,0,20.465,7H13.5V6.5a.5.5,0,0,0-1,0v1A.5.5,0,0,0,13,8h7.465a.4.4,0,0,1,.276.113l2.145,2.145a.4.4,0,0,1,.114.276V22.611a.39.39,0,0,1-.389.389H11.889a.39.39,0,0,1-.389-.389V16.5A.5.5,0,0,0,11,16H10a.5.5,0,0,0,0,1h.5v5.611A1.39,1.39,0,0,0,11.889,24H22.611A1.39,1.39,0,0,0,24,22.611V10.534a1.381,1.381,0,0,0-.406-.982" fill="#fff"/>\n    </g>\n  </svg>\n  ',downloadPDF:'\n <svg id="Layer_2" xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="Layer_1-2">\n    <path class="cls-1"\n      d="m3.64,22.95H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.44c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.59-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.95c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM19.41,4.99h-3.35c-.27,0-.49-.21-.49-.48V1.28c1.86.52,3.31,1.92,3.85,3.71Z" />\n    <path class="cls-1"\n      d="m8.82,14.97h-2.07c-.3,0-.54.23-.54.52v7.98c0,.29.24.52.54.52s.54-.23.54-.52v-3.47h1.53c1.44,0,2.61-1.13,2.61-2.52s-1.17-2.52-2.61-2.52Zm0,3.99h-1.53v-2.95h1.53c.84,0,1.53.66,1.53,1.47s-.69,1.47-1.53,1.47Z" />\n    <path class="cls-1"\n      d="m23.46,15h-2.69c-1.19,0-2.15.9-2.15,2.01v6.47c0,.29.24.52.54.52s.54-.23.54-.52v-3.31h2.05c.3,0,.54-.23.54-.52s-.24-.52-.54-.52h-2.05v-2.11c0-.53.48-.97,1.07-.97h2.69c.3,0,.54-.23.54-.52s-.24-.52-.54-.52Z" />\n    <path class="cls-1"\n      d="m12.95,14.97c-.3,0-.54.23-.54.52v7.98c0,.29.24.52.54.52,2.58,0,4.68-2.02,4.68-4.51s-2.1-4.51-4.68-4.51Zm.54,7.94v-6.86c1.73.25,3.06,1.69,3.06,3.43s-1.33,3.18-3.06,3.43Z" />\n    <path class="cls-1"\n      d="m7.86,10.46c.07.03.15.04.23.04s.15-.01.23-.04c.07-.03.14-.07.19-.12l2.66-2.47c.23-.21.23-.56,0-.78s-.6-.21-.84,0l-1.65,1.53v-4.58c0-.3-.26-.55-.59-.55s-.59.25-.59.55v4.58l-1.65-1.53c-.23-.21-.6-.21-.84,0s-.23.56,0,.78l2.66,2.47c.05.05.12.09.19.12Z" />\n  </g>\n</svg>\n  ',downloadPNG:'\n    <svg id="Layer_2" xmlns="http://www.w3.org/2000/svg" width="24" height="24"  viewBox="0 0 24 24">\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="Layer_1-2">\n    <path class="cls-1"\n      d="m17.05,14.93c-.27,0-.48.22-.48.5v5.95l-2.97-6.18c-.1-.21-.32-.32-.54-.26-.22.05-.37.25-.37.49v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-5.95l2.97,6.18c.08.17.25.28.43.28.04,0,.07,0,.11-.01.22-.05.37-.25.37-.49v-8.07c0-.28-.21-.5-.48-.5Z" />\n    <path class="cls-1"\n      d="m8.64,14.93h-1.94c-.27,0-.48.22-.48.5v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-3.53h1.46c1.34,0,2.42-1.13,2.42-2.52s-1.09-2.52-2.42-2.52Zm0,4.03h-1.46v-3.04h1.46c.81,0,1.46.68,1.46,1.52s-.66,1.52-1.46,1.52Z" />\n    <path class="cls-1"\n      d="m23.52,18.62c.27,0,.48-.22.48-.5v-.67c0-1.39-1.09-2.52-2.42-2.52s-2.42,1.13-2.42,2.52v4.03c0,1.39,1.09,2.52,2.42,2.52s2.42-1.13,2.42-2.52v-.67c0-.28-.21-.5-.48-.5h-1.29c-.27,0-.48.22-.48.5s.21.5.48.5h.81v.17c0,.84-.65,1.52-1.46,1.52s-1.46-.68-1.46-1.52v-4.03c0-.84.65-1.52,1.46-1.52s1.46.68,1.46,1.52v.67c0,.28.21.5.48.5Z" />\n    <path class="cls-1"\n      d="m3.65,22.96H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.45c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.6-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.96c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM15.58,1.28c1.86.52,3.31,1.92,3.85,3.71h-3.36c-.27,0-.49-.21-.49-.48V1.28Z" />\n    <path class="cls-1"\n      d="m10.32,7.11l-1.65,1.53v-4.58c0-.3-.26-.55-.59-.55s-.59.25-.59.55v4.58l-1.65-1.53c-.23-.21-.6-.21-.84,0s-.23.56,0,.78l2.66,2.47c.05.05.12.09.19.12.07.03.15.04.23.04s.15-.01.23-.04c.07-.03.14-.07.19-.12l2.66-2.47c.23-.21.23-.56,0-.78-.23-.21-.6-.21-.84,0Z" />\n  </g>\n</svg>\n  ',delete:'\n  <svg id="delete" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n    <defs>\n      <clipPath id="deleteclip-path">\n        <rect id="Rectangle_2735" data-name="Rectangle 2735" width="24" height="24" fill="#fff"/>\n      </clipPath>\n    </defs>\n    <g id="Group_523" data-name="Group 523" clip-path="url(#deleteclip-path)">\n      <path id="Path_1447" data-name="Path 1447" d="M23.5,4H17V1.5A1.5,1.5,0,0,0,15.5,0h-7A1.5,1.5,0,0,0,7,1.5V4H.5a.5.5,0,0,0,0,1H2.55L4.314,21.761A2.494,2.494,0,0,0,6.8,24H17.2a2.494,2.494,0,0,0,2.485-2.239L21.45,5H23.5a.5.5,0,0,0,0-1M8,1.5A.5.5,0,0,1,8.5,1h7a.5.5,0,0,1,.5.5V4H8ZM18.691,21.657A1.5,1.5,0,0,1,17.2,23H6.8a1.5,1.5,0,0,1-1.492-1.343L3.555,5h16.89Z" fill="#fff"/>\n      <path id="Path_1448" data-name="Path 1448" d="M12,8.5a.5.5,0,0,0-.5.5V19.5a.5.5,0,0,0,1,0V9a.5.5,0,0,0-.5-.5" fill="#fff"/>\n      <path id="Path_1449" data-name="Path 1449" d="M16,8.976l-.5,10.5a.5.5,0,0,0,.476.523H16a.5.5,0,0,0,.5-.476l.5-10.5a.5.5,0,1,0-1-.048" fill="#fff"/>\n      <path id="Path_1450" data-name="Path 1450" d="M7.476,8.5A.5.5,0,0,0,7,9.024l.5,10.5A.5.5,0,0,0,8,20h.025a.5.5,0,0,0,.475-.523L8,8.977A.5.5,0,0,0,7.476,8.5" fill="#fff"/>\n    </g>\n  </svg>\n  ',back:'\n  <svg id="back" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n    <defs>\n      <clipPath id="backclip-path">\n        <rect id="Rectangle_2781" data-name="Rectangle 2781" width="24" height="24" fill="#fff"/>\n      </clipPath>\n    </defs>\n    <g id="Group_597" data-name="Group 597" clip-path="url(#backclip-path)">\n      <path id="Path_1555" data-name="Path 1555" d="M0,12A12,12,0,1,0,12,0,12.013,12.013,0,0,0,0,12m1,0A11,11,0,1,1,12,23,11.013,11.013,0,0,1,1,12" fill="#fff"/>\n      <path id="Path_1556" data-name="Path 1556" d="M4.138,12a.17.17,0,0,1,.005-.024.512.512,0,0,1,.033-.168.532.532,0,0,1,.113-.17l4.219-4.29a.5.5,0,0,1,.714,0,.51.51,0,0,1,0,.719L5.855,11.491h13.5a.509.509,0,0,1,0,1.018H5.853l3.373,3.428a.512.512,0,0,1,0,.72.5.5,0,0,1-.714,0L4.284,12.359a.438.438,0,0,1-.056-.086.5.5,0,0,1-.051-.078A.521.521,0,0,1,4.138,12h0" fill="#fff"/>\n    </g>\n  </svg>\n  ',emptyLibrary:'\n  <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="291.648" height="257.641" viewBox="0 0 291.648 257.641">\n    <defs>\n      <clipPath id="emptyLibraryclip-path">\n        <rect id="Rectangle_2706" data-name="Rectangle 2706" width="291.648" height="257.641" transform="translate(12.66)" fill="none"/>\n      </clipPath>\n    </defs>\n    <g id="image-empty" transform="translate(-12.66)">\n      <g id="Group_471" data-name="Group 471" clip-path="url(#emptyLibraryclip-path)">\n        <path id="Path_1418" data-name="Path 1418" d="M160.751,255.727c-66.485,0-118.227-5.845-142.606-73.507-24.415-67.766,19.034-164.7,91.047-166.173,48.757-1,31.942,48.623,74.131,72.638,32.339,18.408,117.378-36.39,113.723,42.777-3.321,71.951-64.267,124.265-136.3,124.265" transform="translate(1.351 1.915)" fill="#f8f8f8"/>\n        <path id="Path_1419" data-name="Path 1419" d="M18.1,93.9a9.048,9.048,0,1,1-9.048-9.048A9.048,9.048,0,0,1,18.1,93.9" transform="translate(12.66 5.997)" fill="#e0e0e0"/>\n        <path id="Path_1420" data-name="Path 1420" d="M230.481,202.978a9.048,9.048,0,1,1-9.048-9.048,9.048,9.048,0,0,1,9.048,9.048" transform="translate(25.364 23.16)" fill="#e0e0e0"/>\n        <path id="Path_1421" data-name="Path 1421" d="M34.644,204.233a5.928,5.928,0,1,1-5.928-5.928,5.928,5.928,0,0,1,5.928,5.928" transform="translate(2.721 23.683)" fill="#e0e0e0"/>\n        <path id="Path_1422" data-name="Path 1422" d="M190.8,199.7c0,1.208-25.187,7.8-54.651,7.8S84.1,200.906,84.1,199.7s22.064-4.679,51.527-4.679S190.8,198.493,190.8,199.7" transform="translate(10.044 23.29)" fill="#e0e0e0"/>\n        <path id="Path_1423" data-name="Path 1423" d="M278.22,131.008a13.14,13.14,0,1,1-13.141-13.14A13.142,13.142,0,0,1,278.22,131.008Z" transform="translate(23.088 14.076)" fill="none" stroke="#e0e0e0" stroke-miterlimit="10" stroke-width="2"/>\n        <path id="Path_1424" data-name="Path 1424" d="M137.744,113.388V195.23L58.638,161.4V84.531s79.6,29.354,79.106,28.857" transform="translate(7.003 10.095)" fill="#fff4eb"/>\n        <path id="Path_1425" data-name="Path 1425" d="M137.744,113.388V195.23L58.638,161.4V84.531S138.241,113.885,137.744,113.388Z" transform="translate(7.003 10.095)" fill="none" stroke="#f4cba2" stroke-miterlimit="10" stroke-width="1"/>\n        <path id="Path_1426" data-name="Path 1426" d="M129.224,113.388V195.23L208.331,161.4V84.531s-79.6,29.354-79.106,28.857" transform="translate(15.432 10.095)" fill="#fff4eb"/>\n        <path id="Path_1427" data-name="Path 1427" d="M129.224,113.388V195.23L208.331,161.4V84.531S128.727,113.885,129.224,113.388Z" transform="translate(15.432 10.095)" fill="none" stroke="#f4cba2" stroke-miterlimit="10" stroke-width="1"/>\n        <path id="Path_1428" data-name="Path 1428" d="M136.187,63.156,58.139,86.447,137.649,116.3l79.6-29.7Z" transform="translate(6.943 7.542)" fill="#f2c097"/>\n        <path id="Path_1429" data-name="Path 1429" d="M40.67,110.107l19.994-25.58L139.1,112.942l-22.392,26.6Z" transform="translate(4.857 10.095)" fill="#f9dec2"/>\n        <path id="Path_1430" data-name="Path 1430" d="M60.952,85.263l77.3,28-21.618,25.681L41.672,109.928Zm-.382-1.329L39.861,110.427l77.116,29.851,23.165-27.519Z" transform="translate(4.76 10.024)" fill="#f4cba2"/>\n        <path id="Path_1431" data-name="Path 1431" d="M129.194,113.529l23.321,27.861,75.561-30.038-19.4-26.836Z" transform="translate(15.429 10.093)" fill="#f9dec2"/>\n        <path id="Path_1432" data-name="Path 1432" d="M129.194,113.529l23.321,27.861,75.561-30.038-19.4-26.836Z" transform="translate(15.429 10.093)" fill="none" stroke="#f4cba2" stroke-miterlimit="10" stroke-width="1"/>\n        <line id="Line_79" data-name="Line 79" x1="29.852" y1="30.847" transform="translate(46.611 39.852)" fill="none" stroke="#e5e5e5" stroke-miterlimit="10" stroke-width="3"/>\n        <line id="Line_80" data-name="Line 80" x1="13.433" y1="29.852" transform="translate(95.866 25.921)" fill="none" stroke="#e5e5e5" stroke-miterlimit="10" stroke-width="3"/>\n        <line id="Line_81" data-name="Line 81" y1="49.255" x2="1.492" transform="translate(141.638 0.05)" fill="none" stroke="#e5e5e5" stroke-miterlimit="10" stroke-width="3"/>\n        <line id="Line_82" data-name="Line 82" y1="30.847" x2="13.433" transform="translate(172.982 25.424)" fill="none" stroke="#e5e5e5" stroke-miterlimit="10" stroke-width="3"/>\n        <line id="Line_83" data-name="Line 83" y1="30.847" x2="32.339" transform="translate(205.818 39.354)" fill="none" stroke="#e5e5e5" stroke-miterlimit="10" stroke-width="3"/>\n      </g>\n    </g>\n  </svg>\n    ',newDoc:'\n    <svg id="add-new-doc" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n      <defs>\n        <clipPath id="newDocclip-path">\n          <rect id="Rectangle_2737" data-name="Rectangle 2737" width="24" height="24" fill="#fff"/>\n        </clipPath>\n      </defs>\n      <g id="Group_527" data-name="Group 527" clip-path="url(#newDocclip-path)">\n        <path id="Path_1453" data-name="Path 1453" d="M12,0A12,12,0,1,0,24,12,12.013,12.013,0,0,0,12,0m0,22.957A10.957,10.957,0,1,1,22.957,12,10.97,10.97,0,0,1,12,22.957" fill="#fff"/>\n        <path id="Path_1454" data-name="Path 1454" d="M17.739,11.478H12.522V6.261a.522.522,0,0,0-1.044,0v5.217H6.261a.522.522,0,1,0,0,1.043h5.217v5.218a.522.522,0,0,0,1.044,0V12.521h5.217a.522.522,0,1,0,0-1.043" fill="#fff"/>\n      </g>\n    </svg>\n    ',uploadedFiles:'\n    <svg id="uploaded-files" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n      <defs>\n        <clipPath id="uploadedFilesclip-path">\n          <rect id="Rectangle_2740" data-name="Rectangle 2740" width="24" height="24" fill="#fff"/>\n        </clipPath>\n      </defs>\n      <g id="Group_533" data-name="Group 533" clip-path="url(#uploadedFilesclip-path)">\n        <path id="Path_1460" data-name="Path 1460" d="M10,12c-5.3,0-9-1.845-9-3.5V6.482C2.6,7.984,5.986,9,10,9s7.4-1.016,9-2.518V9a.5.5,0,0,0,1,0V4.5C20,1.977,15.611,0,10,0S0,1.977,0,4.5v13c0,2.365,3.777,4.248,8.98,4.478H9a.5.5,0,0,0,.022-1C4.068,20.762,1,19,1,17.5V15.014c1.376,1.287,4.072,2.209,7.468,2.434H8.5a.5.5,0,0,0,.033-1C4.31,16.17,1,14.655,1,13V10.482C2.6,11.984,5.986,13,10,13a.5.5,0,0,0,0-1M10,1c5.305,0,9,1.845,9,3.5S15.307,8,10,8,1,6.155,1,4.5,4.7,1,10,1" fill="#fff"/>\n        <path id="Path_1461" data-name="Path 1461" d="M17.5,11A6.5,6.5,0,1,0,24,17.5,6.508,6.508,0,0,0,17.5,11m0,12A5.5,5.5,0,1,1,23,17.5,5.507,5.507,0,0,1,17.5,23" fill="#fff"/>\n        <path id="Path_1462" data-name="Path 1462" d="M19.5,17H18V14.5a.5.5,0,0,0-1,0v3a.5.5,0,0,0,.5.5h2a.5.5,0,0,0,0-1" fill="#fff"/>\n      </g>\n    </svg>  \n    ',print:'\n    <svg id="print" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n      <defs>\n        <clipPath id="printclip-path">\n          <rect id="Rectangle_2742" data-name="Rectangle 2742" width="24" height="24" fill="#fff"/>\n        </clipPath>\n      </defs>\n      <g id="Group_537" data-name="Group 537" clip-path="url(#printclip-path)">\n        <path id="Path_1465" data-name="Path 1465" d="M16.5,19h-9a.5.5,0,0,0,0,1h9a.5.5,0,0,0,0-1" fill="#fff"/>\n        <path id="Path_1466" data-name="Path 1466" d="M16.5,16h-9a.5.5,0,0,0,0,1h9a.5.5,0,0,0,0-1" fill="#fff"/>\n        <path id="Path_1467" data-name="Path 1467" d="M21.5,6H2.5A2.512,2.512,0,0,0,0,8.5v6A2.511,2.511,0,0,0,2.5,17H5v5.5A1.5,1.5,0,0,0,6.5,24h11A1.5,1.5,0,0,0,19,22.5V17h2.5A2.51,2.51,0,0,0,24,14.5v-6A2.511,2.511,0,0,0,21.5,6M18,22.5a.5.5,0,0,1-.5.5H6.5a.5.5,0,0,1-.5-.5V14H18Zm5-8A1.509,1.509,0,0,1,21.5,16H19V13.5a.5.5,0,0,0-.5-.5H5.5a.5.5,0,0,0-.5.5V16H2.5A1.509,1.509,0,0,1,1,14.5v-6A1.509,1.509,0,0,1,2.5,7h19A1.509,1.509,0,0,1,23,8.5Z" fill="#fff"/>\n        <path id="Path_1468" data-name="Path 1468" d="M5.5,5A.5.5,0,0,0,6,4.5V1h8V4.5a.5.5,0,0,0,.5.5h4a.5.5,0,0,0,.5-.5V3.913a1.49,1.49,0,0,0-.439-1.059L16.147.44A1.488,1.488,0,0,0,15.086,0H5.5A.5.5,0,0,0,5,.5v4a.5.5,0,0,0,.5.5m9.94-3.854,2.414,2.415A.5.5,0,0,1,18,3.913V4H15V1h.086a.508.508,0,0,1,.354.146" fill="#fff"/>\n        <path id="Path_1469" data-name="Path 1469" d="M3.5,8A1.5,1.5,0,1,0,5,9.5,1.5,1.5,0,0,0,3.5,8m0,2A.5.5,0,1,1,4,9.5a.5.5,0,0,1-.5.5" fill="#fff"/>\n      </g>\n    </svg>\n    ',uploadPDF:'\n     <svg id="Layer_2" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24" >\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="Layer_1-2">\n    <path class="cls-1 "\n      d="m3.64,22.95H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.44c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.59-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.95c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM19.41,4.99h-3.35c-.27,0-.49-.21-.49-.48V1.28c1.86.52,3.31,1.92,3.85,3.71Z" />\n    <path class="cls-1 "\n      d="m8.82,14.97h-2.07c-.3,0-.54.23-.54.52v7.98c0,.29.24.52.54.52s.54-.23.54-.52v-3.47h1.53c1.44,0,2.61-1.13,2.61-2.52s-1.17-2.52-2.61-2.52Zm0,3.99h-1.53v-2.95h1.53c.84,0,1.53.66,1.53,1.47s-.69,1.47-1.53,1.47Z" />\n    <path class="cls-1 "\n      d="m23.46,15h-2.69c-1.19,0-2.15.9-2.15,2.01v6.47c0,.29.24.52.54.52s.54-.23.54-.52v-3.31h2.05c.3,0,.54-.23.54-.52s-.24-.52-.54-.52h-2.05v-2.11c0-.53.48-.97,1.07-.97h2.69c.3,0,.54-.23.54-.52s-.24-.52-.54-.52Z" />\n    <path class="cls-1 "\n      d="m12.95,14.97c-.3,0-.54.23-.54.52v7.98c0,.29.24.52.54.52,2.58,0,4.68-2.02,4.68-4.51s-2.1-4.51-4.68-4.51Zm.54,7.94v-6.86c1.73.25,3.06,1.69,3.06,3.43s-1.33,3.18-3.06,3.43Z" />\n    <path class="cls-1" transform="scale(1, -1) translate(0, -14)"\n      d="m7.86,10.46c.07.03.15.04.23.04s.15-.01.23-.04c.07-.03.14-.07.19-.12l2.66-2.47c.23-.21.23-.56,0-.78s-.6-.21-.84,0l-1.65,1.53v-4.58c0-.3-.26-.55-.59-.55s-.59.25-.59.55v4.58l-1.65-1.53c-.23-.21-.6-.21-.84,0s-.23.56,0,.78l2.66,2.47c.05.05.12.09.19.12Z" />\n  </g>\n</svg>\n    ',uploadPNG:'\n<svg id="Layer_2" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24" >\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="Layer_1-2">\n    <path class="cls-1"\n      d="m17.05,14.93c-.27,0-.48.22-.48.5v5.95l-2.97-6.18c-.1-.21-.32-.32-.54-.26-.22.05-.37.25-.37.49v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-5.95l2.97,6.18c.08.17.25.28.43.28.04,0,.07,0,.11-.01.22-.05.37-.25.37-.49v-8.07c0-.28-.21-.5-.48-.5Z" />\n    <path class="cls-1"\n      d="m8.64,14.93h-1.94c-.27,0-.48.22-.48.5v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-3.53h1.46c1.34,0,2.42-1.13,2.42-2.52s-1.09-2.52-2.42-2.52Zm0,4.03h-1.46v-3.04h1.46c.81,0,1.46.68,1.46,1.52s-.66,1.52-1.46,1.52Z" />\n    <path class="cls-1"\n      d="m23.52,18.62c.27,0,.48-.22.48-.5v-.67c0-1.39-1.09-2.52-2.42-2.52s-2.42,1.13-2.42,2.52v4.03c0,1.39,1.09,2.52,2.42,2.52s2.42-1.13,2.42-2.52v-.67c0-.28-.21-.5-.48-.5h-1.29c-.27,0-.48.22-.48.5s.21.5.48.5h.81v.17c0,.84-.65,1.52-1.46,1.52s-1.46-.68-1.46-1.52v-4.03c0-.84.65-1.52,1.46-1.52s1.46.68,1.46,1.52v.67c0,.28.21.5.48.5Z" />\n    <path class="cls-1"\n      d="m3.65,22.96H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.45c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.6-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.96c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM15.58,1.28c1.86.52,3.31,1.92,3.85,3.71h-3.36c-.27,0-.49-.21-.49-.48V1.28Z" />\n    <path class="cls-1" transform="scale(1, -1) translate(0, -14)"\n      d="m10.32,7.11l-1.65,1.53v-4.58c0-.3-.26-.55-.59-.55s-.59.25-.59.55v4.58l-1.65-1.53c-.23-.21-.6-.21-.84,0s-.23.56,0,.78l2.66,2.47c.05.05.12.09.19.12.07.03.15.04.23.04s.15-.01.23-.04c.07-.03.14-.07.19-.12l2.66-2.47c.23-.21.23-.56,0-.78-.23-.21-.6-.21-.84,0Z" />\n  </g>\n</svg>\n    ',sharePDF:'\n <svg id="sharePdf" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24" >\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="sharePdf">\n    <path class="cls-1"\n      d="m3.64,22.95H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.44c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.59-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.95c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM19.41,4.99h-3.35c-.27,0-.49-.21-.49-.48V1.28c1.86.52,3.31,1.92,3.85,3.71Z" />\n    <path class="cls-1"\n      d="m8.82,14.97h-2.07c-.3,0-.54.23-.54.52v7.98c0,.29.24.52.54.52s.54-.23.54-.52v-3.47h1.53c1.44,0,2.61-1.13,2.61-2.52s-1.17-2.52-2.61-2.52Zm0,3.99h-1.53v-2.95h1.53c.84,0,1.53.66,1.53,1.47s-.69,1.47-1.53,1.47Z" />\n    <path class="cls-1"\n      d="m23.46,15h-2.69c-1.19,0-2.15.9-2.15,2.01v6.47c0,.29.24.52.54.52s.54-.23.54-.52v-3.31h2.05c.3,0,.54-.23.54-.52s-.24-.52-.54-.52h-2.05v-2.11c0-.53.48-.97,1.07-.97h2.69c.3,0,.54-.23.54-.52s-.24-.52-.54-.52Z" />\n    <path class="cls-1"\n      d="m12.95,14.97c-.3,0-.54.23-.54.52v7.98c0,.29.24.52.54.52,2.58,0,4.68-2.02,4.68-4.51s-2.1-4.51-4.68-4.51Zm.54,7.94v-6.86c1.73.25,3.06,1.69,3.06,3.43s-1.33,3.18-3.06,3.43Z" />\n    <path transform="scale(0.4, -0.4) translate(8, -30)" stroke="#fff" fill="#fff" stroke-width="1px" d="M19.489,15.009h0c-.008,0-.014,0-.022,0a4.465,4.465,0,0,0-3.749,2.052l-7-3.5a4.482,4.482,0,0,0,0-3.1l7-3.5a4.466,4.466,0,0,0,3.771,2.053l.018,0A4.516,4.516,0,1,0,15.282,6.06L8.257,9.574a4.49,4.49,0,1,0-4.793,6.814,4.548,4.548,0,0,0,1.043.122,4.468,4.468,0,0,0,3.755-2.056l7.018,3.511a4.485,4.485,0,1,0,4.209-2.956M17.13,1.914a3.508,3.508,0,1,1,2.366,6.1h-.01l-.011,0a3.476,3.476,0,0,1-3.112-1.932l0-.006a3.525,3.525,0,0,1,.769-4.162M3.693,15.415a3.5,3.5,0,1,1,3.931-4.967v0a3.47,3.47,0,0,1,0,3.119l0,0a3.479,3.479,0,0,1-3.931,1.842m17.636,7.066a3.5,3.5,0,0,1-4.971-4.53l0,0a3.477,3.477,0,0,1,3.126-1.936l.011,0a3.5,3.5,0,0,1,1.831,6.472" />\n  </g>\n</svg>\n  ',sharePNG:'\n<svg id="sharePng" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24" >\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="sharePng">\n    <path class="cls-1"\n      d="m17.05,14.93c-.27,0-.48.22-.48.5v5.95l-2.97-6.18c-.1-.21-.32-.32-.54-.26-.22.05-.37.25-.37.49v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-5.95l2.97,6.18c.08.17.25.28.43.28.04,0,.07,0,.11-.01.22-.05.37-.25.37-.49v-8.07c0-.28-.21-.5-.48-.5Z" />\n    <path class="cls-1"\n      d="m8.64,14.93h-1.94c-.27,0-.48.22-.48.5v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-3.53h1.46c1.34,0,2.42-1.13,2.42-2.52s-1.09-2.52-2.42-2.52Zm0,4.03h-1.46v-3.04h1.46c.81,0,1.46.68,1.46,1.52s-.66,1.52-1.46,1.52Z" />\n    <path class="cls-1"\n      d="m23.52,18.62c.27,0,.48-.22.48-.5v-.67c0-1.39-1.09-2.52-2.42-2.52s-2.42,1.13-2.42,2.52v4.03c0,1.39,1.09,2.52,2.42,2.52s2.42-1.13,2.42-2.52v-.67c0-.28-.21-.5-.48-.5h-1.29c-.27,0-.48.22-.48.5s.21.5.48.5h.81v.17c0,.84-.65,1.52-1.46,1.52s-1.46-.68-1.46-1.52v-4.03c0-.84.65-1.52,1.46-1.52s1.46.68,1.46,1.52v.67c0,.28.21.5.48.5Z" />\n    <path class="cls-1"\n      d="m3.65,22.96H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.45c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.6-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.96c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM15.58,1.28c1.86.52,3.31,1.92,3.85,3.71h-3.36c-.27,0-.49-.21-.49-.48V1.28Z" />\n    <path transform="scale(0.4, -0.4) translate(8, -30)" stroke="#fff" fill="#fff" stroke-width="1px" d="M19.489,15.009h0c-.008,0-.014,0-.022,0a4.465,4.465,0,0,0-3.749,2.052l-7-3.5a4.482,4.482,0,0,0,0-3.1l7-3.5a4.466,4.466,0,0,0,3.771,2.053l.018,0A4.516,4.516,0,1,0,15.282,6.06L8.257,9.574a4.49,4.49,0,1,0-4.793,6.814,4.548,4.548,0,0,0,1.043.122,4.468,4.468,0,0,0,3.755-2.056l7.018,3.511a4.485,4.485,0,1,0,4.209-2.956M17.13,1.914a3.508,3.508,0,1,1,2.366,6.1h-.01l-.011,0a3.476,3.476,0,0,1-3.112-1.932l0-.006a3.525,3.525,0,0,1,.769-4.162M3.693,15.415a3.5,3.5,0,1,1,3.931-4.967v0a3.47,3.47,0,0,1,0,3.119l0,0a3.479,3.479,0,0,1-3.931,1.842m17.636,7.066a3.5,3.5,0,0,1-4.971-4.53l0,0a3.477,3.477,0,0,1,3.126-1.936l.011,0a3.5,3.5,0,0,1,1.831,6.472" />\n  </g>\n</svg>\n  ',done:'<svg id="done" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <clipPath id="done-path">\n      <rect id="Rectangle_2775" data-name="Rectangle 2775" width="24" height="24" fill="#fe8e14"/>\n    </clipPath>\n  </defs>\n  <g id="Group_584" data-name="Group 584" clip-path="url(#doneclip-path)">\n    <path id="Path_1526" data-name="Path 1526" d="M17.6,6.7l-6.691,9.081L6.313,12.11a.5.5,0,0,0-.625.781l5,4a.508.508,0,0,0,.378.1.493.493,0,0,0,.337-.2l7-9.5A.5.5,0,1,0,17.6,6.7" fill="#fe8e14"/>\n    <path id="Path_1527" data-name="Path 1527" d="M12,0A12,12,0,1,0,24,12,12.013,12.013,0,0,0,12,0m0,23A11,11,0,1,1,23,12,11.013,11.013,0,0,1,12,23" fill="#fe8e14"/>\n  </g>\n</svg>\n',captureAnother:'\n<svg id="capture-another" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="28.761" height="23" viewBox="0 0 28.761 23">\n  <defs>\n    <clipPath id="captureAnotherclip-path">\n      <rect id="Rectangle_2777" data-name="Rectangle 2777" width="28.761" height="23" fill="#fff"/>\n    </clipPath>\n  </defs>\n  <g id="Group_589" data-name="Group 589" clip-path="url(#captureAnotherclip-path)">\n    <path id="Path_1544" data-name="Path 1544" d="M25.877,3.639H21.663a.7.7,0,0,1-.575-.288l-.575-.764C19.264.961,18.59,0,17.44,0H11.4C10.151,0,9.486.961,8.336,2.588l-.674.764a.7.7,0,0,1-.575.288H2.875C.476,3.639,0,5.077,0,6.227v13.9C0,22.041,1.051,23,2.974,23H25.787c1.914,0,2.974-.961,2.974-2.776v-14c-.008-1.147-.485-2.585-2.884-2.585m-.1,18.411H2.974c-1.339,0-2.013-.575-2.013-1.824v-14c0-.863.189-1.626,1.914-1.626H7.188a1.666,1.666,0,0,0,1.339-.674L9.1,3.162c1.15-1.626,1.536-2.2,2.2-2.2H17.34c.674,0,1.15.575,2.3,2.2l.575.764a1.562,1.562,0,0,0,1.339.674h4.313c1.725,0,1.914.764,1.914,1.626v14h.009c0,1.249-.673,1.824-2.012,1.824" fill="#fff"/>\n    <path id="Path_1545" data-name="Path 1545" d="M14.38,6.194a6.5,6.5,0,1,0,6.5,6.5,6.508,6.508,0,0,0-6.5-6.5m0,12a5.5,5.5,0,1,1,5.5-5.5,5.507,5.507,0,0,1-5.5,5.5" fill="#fff"/>\n    <path id="Path_1546" data-name="Path 1546" d="M17.381,12.194h-2.5v-2.5a.5.5,0,0,0-1,0v2.5h-2.5a.5.5,0,0,0,0,1h2.5v2.5a.5.5,0,1,0,1,0v-2.5h2.5a.5.5,0,0,0,0-1" fill="#fff"/>\n  </g>\n</svg>\n',edit:'\n<svg id="edit" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24.002" height="24" viewBox="0 0 24.002 24">\n  <defs>\n    <clipPath id="editclip-path">\n      <rect id="Rectangle_2778" data-name="Rectangle 2778" width="24.002" height="24" fill="none" stroke="currentColor" stroke-width="1"/>\n    </clipPath>\n  </defs>\n  <g id="Group_591" data-name="Group 591" clip-path="url(#editclip-path)">\n    <path id="Path_1547" data-name="Path 1547" d="M21.5,13.5v9a1,1,0,0,1-1,1H1.5a1,1,0,0,1-1-1V3.5a1,1,0,0,1,1-1h11" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="1"/>\n    <path id="Path_1548" data-name="Path 1548" d="M9.824,17.007l-3.99,1.049L7,14.177,20.674.5,23.5,3.328Z" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="1"/>\n  </g>\n</svg>\n',crop:'\n<svg id="crop" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <clipPath id="cropclip-path">\n      <rect id="Rectangle_2787" data-name="Rectangle 2787" width="24" height="24" fill="currentColor"/>\n    </clipPath>\n  </defs>\n  <g id="Group_609" data-name="Group 609" clip-path="url(#cropclip-path)">\n    <path id="Path_1569" data-name="Path 1569" d="M18.95,5.05a.745.745,0,0,1,.243.536V18.2h.974V5.586a1.681,1.681,0,0,0-.521-1.232,1.681,1.681,0,0,0-1.232-.521H5.8v.974h12.61a.745.745,0,0,1,.536.243" fill="currentColor"/>\n    <path id="Path_1570" data-name="Path 1570" d="M5.609,19.17a.789.789,0,0,1-.779-.779V0H3.856V3.833H0v.974H3.856V18.391a1.748,1.748,0,0,0,1.753,1.753H19.193V24h.974V20.144H24V19.17Z" fill="currentColor"/>\n  </g>\n</svg>\n',rotate:'\n<svg id="rotate" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <clipPath id="rotateclip-path">\n      <rect id="Rectangle_2786" data-name="Rectangle 2786" width="24" height="24" fill="#fff"/>\n    </clipPath>\n  </defs>\n  <g id="Group_607" data-name="Group 607" clip-path="url(#rotateclip-path)">\n    <path id="Path_1567" data-name="Path 1567" d="M15.557,11H1.5A1.5,1.5,0,0,0,0,12.5v10A1.5,1.5,0,0,0,1.5,24H15.557a1.5,1.5,0,0,0,1.5-1.5v-10a1.5,1.5,0,0,0-1.5-1.5m.5,11.5a.5.5,0,0,1-.5.5H1.5a.5.5,0,0,1-.5-.5v-10a.5.5,0,0,1,.5-.5H15.557a.5.5,0,0,1,.5.5Z" fill="#fff"/>\n    <path id="Path_1568" data-name="Path 1568" d="M21.022,6.667A9.785,9.785,0,0,0,13.845,3.69h-2.2l2.9-2.876L13.83,0,9.624,4.181,13.83,8.387l.717-.814-2.9-2.9h2.2a8.825,8.825,0,0,1,6.5,2.69,8.859,8.859,0,0,1,2.677,6.483l.982,0a9.777,9.777,0,0,0-2.978-7.175" fill="#fff"/>\n  </g>\n</svg>\n',annotate:'\n<svg id="annotate" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <clipPath id="annotateclip-path">\n      <rect id="Rectangle_2785" data-name="Rectangle 2785" width="24" height="24" fill="currentColor"/>\n    </clipPath>\n  </defs>\n  <g id="Group_605" data-name="Group 605" clip-path="url(#annotateclip-path)">\n    <path id="Path_1561" data-name="Path 1561" d="M9.575,21H4.934A2.5,2.5,0,0,0,2.99,19.051V4.949A2.5,2.5,0,0,0,4.934,3H18.993a2.5,2.5,0,0,0,1.943,1.949V11.11a.5.5,0,1,0,1,0V4.949A2.5,2.5,0,1,0,18.993,2H4.934A2.493,2.493,0,1,0,2,4.949v14.1A2.5,2.5,0,1,0,4.934,22H9.575a.5.5,0,0,0,0-1M21.435,1a1.5,1.5,0,1,1-1.5,1.5,1.5,1.5,0,0,1,1.5-1.5M1,2.5A1.495,1.495,0,1,1,2.493,4,1.5,1.5,0,0,1,1,2.5M2.493,23a1.5,1.5,0,1,1,1.494-1.5A1.5,1.5,0,0,1,2.493,23" fill="currentColor"/>\n    <path id="Path_1562" data-name="Path 1562" d="M23.561,14.718l-.908-.912a1.483,1.483,0,0,0-1.944-.149l-4.539,3.35-2.563,2.571a.5.5,0,0,0,0,.707l.277.278-1.791,1.711A1,1,0,0,0,12.779,24h2.883a.5.5,0,0,0,.333-.128l.626-.563.509.511a.5.5,0,0,0,.7,0l2.613-2.627,3.264-4.534a1.5,1.5,0,0,0-.151-1.941M15.471,23H12.779l1.81-1.73L15.915,22.6Zm7.434-6.928-3.214,4.475-2.208,2.212-2.82-2.829,2.155-2.167,4.482-3.3a.5.5,0,0,1,.647.05h0l.907.912a.5.5,0,0,1,.05.647" fill="currentColor"/>\n    <path id="Path_1563" data-name="Path 1563" d="M5.082,10.014a4.479,4.479,0,0,0,.738,2.46c.007.012.007.025.015.036l.009.009a4.5,4.5,0,1,0-.762-2.505M9.07,6.565V9.746L6.428,11.512A3.464,3.464,0,0,1,9.07,6.565m3.988,3.449a3.474,3.474,0,0,1-6.075,2.329L9.845,10.43a.5.5,0,0,0,.222-.416V6.565a3.491,3.491,0,0,1,2.991,3.449" fill="currentColor"/>\n    <path id="Path_1564" data-name="Path 1564" d="M18.542,6.534H16.049a.5.5,0,0,0,0,1h2.493a.5.5,0,0,0,0-1" fill="currentColor"/>\n    <path id="Path_1565" data-name="Path 1565" d="M18.542,9.534H16.049a.5.5,0,0,0,0,1h2.493a.5.5,0,0,0,0-1" fill="currentColor"/>\n    <path id="Path_1566" data-name="Path 1566" d="M18.542,12.534H16.049a.5.5,0,0,0,0,1h2.493a.5.5,0,0,0,0-1" fill="currentColor"/>\n  </g>\n</svg>\n',defaultDocument:'\n<svg id="document" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="20" height="24" viewBox="0 0 20 24">\n  <defs>\n    <clipPath id="documentclip-path">\n      <rect id="Rectangle_2779" data-name="Rectangle 2779" width="20" height="24" fill="#9AA0A6"/>\n    </clipPath>\n  </defs>\n  <g id="Group_593" data-name="Group 593" clip-path="url(#documentclip-path)">\n    <path id="Path_1549" data-name="Path 1549" d="M19.56,3.85,16.15.44A1.52,1.52,0,0,0,15.09,0H4.5A1.5,1.5,0,0,0,3,1.5V3H1.5A1.5,1.5,0,0,0,0,4.5v18A1.5,1.5,0,0,0,1.5,24h14A1.5,1.5,0,0,0,17,22.5V21h1.5A1.5,1.5,0,0,0,20,19.5V4.91a1.52,1.52,0,0,0-.44-1.06M16,22.5a.5.5,0,0,1-.5.5H1.5a.5.5,0,0,1-.5-.5V4.5A.5.5,0,0,1,1.5,4H3V19.5A1.5,1.5,0,0,0,4.5,21H16Zm3-3a.5.5,0,0,1-.5.5H4.5a.5.5,0,0,1-.5-.5V1.5A.5.5,0,0,1,4.5,1H15.09a.492.492,0,0,1,.35.15l3.41,3.41a.468.468,0,0,1,.15.35Z" fill="#9AA0A6"/>\n    <path id="Path_1550" data-name="Path 1550" d="M7.66,6.4h5.18a.5.5,0,0,0,0-1H7.66a.5.5,0,0,0,0,1" fill="#9AA0A6"/>\n    <path id="Path_1551" data-name="Path 1551" d="M15.5,9.08h-8a.5.5,0,1,0,0,1h8a.5.5,0,1,0,0-1" fill="#9AA0A6"/>\n    <path id="Path_1552" data-name="Path 1552" d="M15.5,13.08h-8a.5.5,0,1,0,0,1h8a.5.5,0,0,0,0-1" fill="#9AA0A6"/>\n  </g>\n</svg>\n',selectedCircle:'\n<svg id="selected-circle" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <clipPath id="selected-circleclip-path">\n      <rect id="Rectangle_2751" data-name="Rectangle 2751" width="24" height="24" fill="none"/>\n    </clipPath>\n  </defs>\n  <g id="Group_547" data-name="Group 547" clip-path="url(#selected-circleclip-path)">\n    <path id="Path_1478" data-name="Path 1478" d="M24,12A12,12,0,1,1,12,0,12,12,0,0,1,24,12" fill="#fe8e14"/>\n    <path id="Path_1479" data-name="Path 1479" d="M10.52,17.174a2.517,2.517,0,0,1-1.757-.725L5.757,13.442a1,1,0,0,1,1.414-1.414l3,3a.49.49,0,0,0,.387.144.511.511,0,0,0,.373-.2l5.8-7.742a1,1,0,0,1,1.6,1.2l-5.81,7.748a2.514,2.514,0,0,1-1.83.994c-.059,0-.117.006-.176.006" fill="#fff"/>\n  </g>\n</svg>\n',filter:'\n<svg id="Layer_2" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 25 24" width="25" height="24" >\n  <defs>\n    <style>\n      .cls-1 {\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="Layer_1-2">\n    <path class="cls-1"\n      d="m20.27,8.85c.04-.31.06-.62.06-.95,0-4.36-3.51-7.9-7.83-7.9s-7.83,3.54-7.83,7.9c0,.32.02.63.06.94C1.95,10.06,0,12.85,0,16.1c0,4.36,3.51,7.9,7.83,7.9,1.75,0,3.37-.59,4.67-1.58,1.31.99,2.92,1.58,4.67,1.58,4.32,0,7.83-3.54,7.83-7.9,0-3.25-1.95-6.04-4.73-7.25Zm-3.09,14.1c-1.43,0-2.76-.45-3.86-1.22-.29-.2-.56-.43-.81-.67-1.3-1.25-2.11-3-2.11-4.95,0-.2.01-.4.03-.59.03-.36.09-.7.17-1.04-.34-.1-.66-.23-.98-.38-.09.35-.16.7-.21,1.07-.04.31-.06.62-.06.95,0,2.2.9,4.19,2.34,5.62-1.1.77-2.43,1.22-3.86,1.22-3.74,0-6.78-3.07-6.78-6.85,0-2.73,1.6-5.09,3.9-6.19.31-.15.64-.28.98-.38.61-.18,1.24-.28,1.91-.28,1.43,0,2.76.45,3.86,1.22.29.2.56.43.81.67.25-.24.53-.47.81-.67-.25-.25-.53-.48-.81-.7-1.31-.99-2.92-1.58-4.67-1.58-.72,0-1.42.11-2.08.29-.02-.2-.03-.39-.03-.59,0-3.78,3.04-6.85,6.78-6.85s6.78,3.07,6.78,6.85c0,.2-.01.4-.03.59-.03.36-.09.7-.17,1.04-.49,2.02-1.87,3.68-3.69,4.55-.31.15-.64.28-.98.38.08.34.14.69.17,1.04.35-.1.69-.21,1.01-.35,2.19-.95,3.85-2.88,4.47-5.24,2.3,1.1,3.9,3.45,3.9,6.19,0,3.78-3.04,6.85-6.78,6.85Z" />\n  </g>\n</svg>\n  ',close:'\n            <svg\n            xmlns="http://www.w3.org/2000/svg"\n            viewBox="0 0 24 24"\n            fill="none"\n            stroke="currentColor"\n            stroke-linecap="round"\n            stroke-linejoin="round"\n            width="24"\n            height="24"\n            stroke-width="2"\n          >\n            <path d="M18 6l-12 12"></path>\n            <path d="M6 6l12 12"></path>\n          </svg>\n'};function b(){return"ontouchstart"in document.documentElement}function y(e){return"string"==typeof e?document.querySelector(e):e instanceof HTMLElement?e:null}function C(e){if(!e)return`Doc-${Date.now()}`;const n=e.lastIndexOf(".");return-1!==n?e.substring(0,n):e}function D(e,n){if(!document.getElementById(e)){const t=document.createElement("style");t.id=e,t.textContent=n,document.head.appendChild(t)}}class V{constructor(e){this.config=e,this.checked=!1,this.isSelectMode=!1,this.createUI(),this.bindEvents()}createUI(){D("mwc-document-item-style",x);const e=s.DDV.documentManager.getDocument(this.config.docId),n=e.pages.length;this.dom=document.createElement("div"),this.dom.className="mwc-document-item",this.dom.innerHTML=`\n      <div class="mwc-document-info-container">\n        <div class="mwc-document-thumbnail">\n          ${f.defaultDocument}\n        </div>\n        <div class="mwc-document-info">\n          <div class="mwc-document-name-container">\n            <div class="mwc-document-name">${e.name}</div>\n            <button type="button" class="mwc-document-rename-btn">\n              ${f.edit}\n            </button>\n          </div>\n          <div class="mwc-document-pages">${n} pages</div>\n        </div>\n      </div>\n      <input type="checkbox" class="mwc-document-checkbox">\n    `,this.checkbox=this.dom.querySelector(".mwc-document-checkbox"),this.renameBtn=this.dom.querySelector(".mwc-document-rename-btn"),this.updateThumbnail(e)}async updateThumbnail(e){const n=this.dom.querySelector(".mwc-document-thumbnail");if(n.textContent="",e.pages[0]){const t=await e.getPageData(e.pages[0]),i=URL.createObjectURL(t.display.data),a=document.createElement("img");a.className="mwc-image-thumbnail",a.alt="mwc-image-thumbnail",a.src=i,n.append(a)}else n.innerHTML=f.defaultDocument}bindEvents(){this.dom.addEventListener("click",(e=>{var n,t;e.target!==this.checkbox&&(this.isSelectMode?this.toggleCheck():null===(t=(n=this.config).onDocumentClick)||void 0===t||t.call(n,this.config.docId))})),this.checkbox.addEventListener("click",(e=>{e.stopPropagation(),this.toggleCheck()})),this.renameBtn.addEventListener("click",(e=>{var n,t;e.stopPropagation(),null===(t=(n=this.config).onRename)||void 0===t||t.call(n,this.config.docId)}))}setSelectMode(e){this.isSelectMode=e,e||this.toggleCheck(!1)}toggleCheck(e){var n,t;this.checked=null!=e?e:!this.checked,this.checkbox.checked=this.checked,this.dom.classList.toggle("selected",this.checked),null===(t=(n=this.config).onCheckedChange)||void 0===t||t.call(n,this.config.docId,this.checked)}getDom(){return this.dom}getUid(){return this.config.docId}update(){const e=s.DDV.documentManager.getDocument(this.config.docId);if(!e)return;const n=this.dom.querySelector(".mwc-document-name"),t=this.dom.querySelector(".mwc-document-pages");n.textContent=e.name,t.textContent=1===e.pages.length?"1 page":`${e.pages.length} pages`,this.updateThumbnail(e)}dispose(){this.dom.remove()}}const x="\n.mwc-document-item {\n  display: grid;\n  grid-template-columns: 90% 10%;\n  background-color: #EFEFEF;\n  cursor: pointer;\n  font-family: Verdana;\n  padding: 15px;\n  align-items: center;\n  border: 2px solid transparent;\n}\n\n.mwc-document-item.selected {\n  border: 2px solid #FE8E14;\n}\n\n.mwc-document-info-container {\n  display: flex;\n  align-items: center;\n  gap: 12px;\n}\n\n.mwc-document-info {\n  display: flex;\n  flex-direction: column;\n  gap: 12px;\n  padding-right: 1rem;\n}\n\n.mwc-document-item .mwc-document-name-container {\n  display: grid;\n  grid-template-columns: 90% 10%;\n}\n\n.mwc-document-item .mwc-document-name-container .mwc-document-name {\n  font-size: 16px;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n\n.mwc-document-item .mwc-document-name-container .mwc-document-rename-btn{\n  background: none;\n  border: none;\n  cursor: pointer;\n}\n\n.mwc-document-item .mwc-document-name-container .mwc-document-rename-btn svg {\n  width: 16px;\n  height: 16px;\n  stroke: black;\n}\n\n.mwc-document-item .mwc-document-pages {\n  color: #888888;\n}\n\n.mwc-document-thumbnail {\n  width: 70px;\n  height: 70px;\n  background-color: #DADCE0;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  flex-shrink: 0;\n}\n\n.mwc-document-thumbnail svg {\n  width: 48px;\n  height: 48px;\n  padding: 1rem;\n}\n\n.mwc-image-thumbnail {\n  width: 100%;\n  height: 100%;\n  object-fit: contain;\n}\n\n.mwc-document-checkbox {\n  cursor: pointer;\n  accent-color: #FE8E14;\n  width: 24px;\n  height: 24px;\n  justify-self: end;\n}\n";var k,P,M,E;!function(e){e.Library="library",e.Page="page",e.Document="document",e.Transfer="transfer",e.History="history",e.Scanner="Scanner"}(k||(k={})),function(e){e.Library="library",e.Page="page",e.Document="document",e.Transfer="transfer",e.History="history",e.Scanner="scanner",e.Correction="correction",e.ScanResult="scan-result"}(P||(P={})),function(e){e.CONFIRM="confirm",e.INPUT="input",e.TOAST="toast"}(M||(M={})),function(e){e.WARNING="warning",e.ERROR="error",e.SUCCESS="success"}(E||(E={}));const S={[E.WARNING]:'\n    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" width="24" height="24" fill="currentColor" class="modal-icon warning">\n  <path width="24" height="24" fill="currentColor"\n    d="M256 48C141.31 48 48 141.31 48 256s93.31 208 208 208 208-93.31 208-208S370.69 48 256 48zm0 319.91a20 20 0 1120-20 20 20 0 01-20 20zm21.72-201.15l-5.74 122a16 16 0 01-32 0l-5.74-121.94v-.05a21.74 21.74 0 1143.44 0z" />\n</svg>\n  ',[E.ERROR]:'\n    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" class="modal-icon error">\n      <path stroke-linecap="round" stroke-linejoin="round" stroke-width="1.5" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z" />\n    </svg>\n  ',[E.SUCCESS]:'\n  <svg id="selected-circle" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" class="modal-icon " width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <clipPath id="selected-circleclip-path">\n      <rect id="Rectangle_2751" data-name="Rectangle 2751" width="24" height="24" fill="none"/>\n    </clipPath>\n  </defs>\n  <g id="Group_547" data-name="Group 547" clip-path="url(#selected-circleclip-path)">\n    <path id="Path_1478" data-name="Path 1478" d="M24,12A12,12,0,1,1,12,0,12,12,0,0,1,24,12" fill="#fe8e14"/>\n    <path id="Path_1479" data-name="Path 1479" d="M10.52,17.174a2.517,2.517,0,0,1-1.757-.725L5.757,13.442a1,1,0,0,1,1.414-1.414l3,3a.49.49,0,0,0,.387.144.511.511,0,0,0,.373-.2l5.8-7.742a1,1,0,0,1,1.6,1.2l-5.81,7.748a2.514,2.514,0,0,1-1.83.994c-.059,0-.117.006-.176.006" fill="#fff"/>\n  </g>\n</svg>'};async function A(e,n,t=E.SUCCESS,i=1500){return await L({container:e,type:M.TOAST,title:n,variant:t,duration:i})}function L({container:e,type:n=M.CONFIRM,variant:t=E.SUCCESS,title:i,message:a,placeholder:o,initialValue:l="",confirmText:s="OK",cancelText:c="CANCEL",validation:d,duration:r,showCloseBtn:h}){if(!document.getElementById("modal-styles")){const e=document.createElement("style");e.id="modal-styles",e.textContent=H,document.head.appendChild(e)}const m=e.style.position;e.style.position||(e.style.position="relative");const u=document.createElement("div");u.className="modal-overlay";const p=n===M.INPUT?`\n        <div class="modal-input-container">\n          <input \n            type="text" \n            class="modal-input" \n            placeholder="${o||""}"\n            value="${l}"\n            maxlength="100"\n          >\n          <div class="modal-error"></div>\n        </div>\n        `:"",v=a?`\n      <div class="modal-message">\n        ${a}\n      </div>\n      `:"";if(n===M.TOAST)return u.classList.add("toast"),u.innerHTML=`\n        <div class="modal-toast">\n          ${S[t]||""}\n          <div class="modal-title">${i}</div>\n        </div>\n      `,e.appendChild(u),new Promise((e=>{const n=u.querySelector(".modal-toast");setTimeout((()=>{n.classList.add("fade-out"),u.remove(),e(null)}),r)}));u.innerHTML=`\n  <div class="modal">\n    ${n===M.CONFIRM?h?`<button type="button" class="close-btn">${f.close}</button>`:S[t]||"":""}\n    <div class="modal-title">${i}</div>\n    ${v}\n    ${p}\n    <div class="modal-actions">\n      <button class="modal-btn cancel">${c}</button>\n      <button class="modal-btn confirm ${t}">${s}</button>\n    </div>\n  </div>\n`,e.appendChild(u);const w=u.querySelector(".modal-input"),g=u.querySelector(".modal-error"),b=u.querySelector(".confirm"),y=u.querySelector(".cancel"),C=u.querySelector(".close-btn");return w&&(w.selectionStart=w.value.length,w.focus()),new Promise((t=>{const i=()=>{if(n===M.INPUT){const e=w.value.trim();if(d){const n=d(e);if(n)return void o(n)}t(e)}else t(!0);a()},a=()=>{u.classList.add("fade-out"),setTimeout((()=>{u.remove(),e.style.position=m}),200)},o=e=>{g.textContent=e,g.style.opacity="1",g.style.height="auto",w.classList.add("error"),w.classList.add("shake"),setTimeout((()=>w.classList.remove("shake")),500)};null==b||b.addEventListener("click",i),null==y||y.addEventListener("click",(()=>{t(!1),a()})),null==C||C.addEventListener("click",(()=>{t(null),a()})),w&&(w.addEventListener("input",(e=>{let n=e.target.value;n=n.replace(/[\x00-\x1F\x7F]/g,""),n.startsWith(" ")&&(n=n.trimStart()),e.target.value=n,g&&(g.style.opacity="0",g.style.height="0px",null==w||w.classList.remove("error")),b.classList.toggle("disabled",!n.trim())})),w.addEventListener("keyup",(e=>{"Enter"===e.key?i():"Escape"===e.key&&(t(!1),a())})),b.classList.toggle("disabled",!w.value.trim())),u.addEventListener("click",(e=>{e.target===u&&(t(null),a())})),document.addEventListener("keyup",(function e(n){"Escape"===n.key&&(document.removeEventListener("keyup",e),t(!1),a())}))}))}const H="\n.modal-overlay {\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background-color: rgba(0, 0, 0, 0.5);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  z-index: 1000;\n  animation: fadeIn 0.2s ease-out;\n}\n\n.modal-overlay.toast {\n  background-color: transparent;\n  pointer-events: none;\n}\n\n.modal-toast {\n  position: absolute;\n  top: 50%;\n  left: 50%;\n  transform: translate(-50%, -50%);\n  background-color: rgba(0, 0, 0, 0.8);\n  color: white;\n  padding: 1rem;\n  border-radius: 8px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  flex-direction: column;\n  gap: 0.5rem;\n  width: 80px;\n  height: 80px;\n  z-index: 1001;\n  opacity: 1;\n  animation: toastIn 0.2s ease-out;\n}\n\n.modal-toast.fade-out {\n  animation: toastOut 0.2s ease-out forwards;\n}\n\n\n.modal-toast .modal-icon {\n  width: 24px;\n  height: 24px;\n}\n\n.modal-overlay:not(.toast) {\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background-color: rgba(0, 0, 0, 0.5);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  z-index: 1000;\n  animation: fadeIn 0.2s ease-out;\n}\n\n.modal-overlay.fade-out {\n  animation: fadeOut 0.2s ease-out;\n}\n\n.modal {\n  background-color: white;\n  padding: 1rem;\n  border-radius: 8px;\n  width: 90%;\n  max-width: 320px;\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  gap: 0.5rem;\n  position: relative;\n}\n\n.modal-icon {\n  width: 48px;\n  height: 48px;\n  margin: 0 auto;\n}\n\n.modal-icon.warning {\n  color: #f59e0b;\n}\n\n.modal-icon.error {\n  stroke: #ef4444;\n}\n\n.modal-title {\n  font-size: 16px;\n  font-family: Verdana;\n  text-align: center;\n  padding-bottom: 1rem;\n}\n\n.modal-toast .modal-title {\n  color: white;\n  padding-bottom: 0;\n  text-align: center;\n}\n\n.modal .close-btn {\n  position: absolute;\n  right: 1rem;\n  top: 1rem;\n  border: none;\n  padding: 0;\n  margin: 0;\n  background-color: transparent;\n  cursor: pointer;\n}\n\n.modal .close-btn svg {\n  color: #858585;\n}\n\n.modal-message {\n  font-size: 14px;\n  font-family: Verdana;\n  color: #666;\n  text-align: center;\n}\n\n.modal-input-container {\n  display: flex;\n  flex-direction: column;\n}\n\n.modal-input {\n  padding: 8px 12px;\n  border: 1px solid #ccc;\n  border-radius: 4px;\n  font-size: 16px;\n  font-family: Verdana;\n  transition: border-color 0.2s;\n}\n\n.modal-input.error {\n  border-color: #ef4444;\n}\n\n.modal-input.shake {\n  animation: shake 0.5s;\n}\n\n.modal-error {\n  color: #ef4444;\n  font-size: 12px;\n  min-height: 0;\n  opacity: 0;\n  transition: opacity 0.2s, height 0.2s;\n}\n\n.modal-actions {\n  display: flex;\n  justify-content: flex-end;\n  gap: 12px;\n  margin-top: 8px;\n}\n\n.modal-btn {\n  padding: 8px 16px;\n  border: none;\n  border-radius: 4px;\n  font-family: Verdana;\n  font-size: 14px;\n  cursor: pointer;\n  transition: opacity 0.2s;\n}\n\n.modal-btn:hover {\n  opacity: 0.9;\n}\n\n.modal-btn.cancel {\n  background-color: #e6e6e6;\n  color: #333;\n}\n\n.modal-btn.confirm {\n background-color: #fe8e14;\n  color: white;\n}\n\n.modal-btn.confirm.warning {\n  background-color: #FE8E14;\n}\n\n.modal-btn.confirm.error {\n  background-color: #ef4444;\n}\n\n.modal-btn.confirm.info {\n  background-color: #FE8E14;\n}\n\n.modal-btn.confirm.disabled {\n  opacity: 0.4;\n  cursor: not-allowed;\n  pointer-events: none;\n}\n\n@keyframes fadeIn {\n  from { opacity: 0; }\n  to { opacity: 1; }\n}\n\n@keyframes fadeOut {\n  from { opacity: 1; }\n  to { opacity: 0; }\n}\n\n@keyframes toastIn {\n  0% { \n    opacity: 0;\n    transform: translate(-50%, calc(-50% + 20px));\n  }\n  100% { \n    opacity: 1;\n    transform: translate(-50%, -50%);\n  }\n}\n\n@keyframes toastOut {\n  0% { \n    opacity: 1;\n    transform: translate(-50%, -50%);\n  }\n  100% { \n    opacity: 0;\n    transform: translate(-50%, calc(-50% - 20px));\n  }\n}\n\n@keyframes shake {\n  0%, 100% { transform: translateX(0); }\n  10%, 30%, 50%, 70%, 90% { transform: translateX(-2px); }\n  20%, 40%, 60%, 80% { transform: translateX(2px); }\n}\n";class T{constructor(e){this.config=e,this.MWCViewElements={headerContainer:null,contentContainer:null,emptyContentContainer:null,toolbarContainer:null,selectedToolbarContainer:null},this.isSelectionMode=!1}initialize(){if(!this.config.container)throw new Error("Create a container element");this.createMWCView()}createMWCView(){this.config.container.textContent="",D("mwc-views-style",B),this.createHeader(),this.createContent(),this.createEmptyContent(),this.createToolbars()}createHeader(e=!0){e&&(this.MWCViewElements.headerContainer=document.createElement("div"),this.MWCViewElements.headerContainer.className="mwc-view-header",this.config.container.appendChild(this.MWCViewElements.headerContainer))}createContent(){this.MWCViewElements.contentContainer=document.createElement("div"),this.MWCViewElements.contentContainer.className="mwc-view-content",this.config.container.appendChild(this.MWCViewElements.contentContainer)}createEmptyContent(){this.MWCViewElements.emptyContentContainer=document.createElement("div"),this.MWCViewElements.emptyContentContainer.className="mwc-view-content-empty",this.config.container.appendChild(this.MWCViewElements.emptyContentContainer)}async setEmptyContent(e){const n=this.MWCViewElements.emptyContentContainer;n.textContent="";try{if("object"==typeof e&&"templatePath"in e){const t=await fetch(e.templatePath);if(!t.ok)throw new Error(`HTTP error! status: ${t.status}`);const i=await t.text();n.innerHTML=i;const a=n.querySelector("template");a&&(n.innerHTML=a.innerHTML),n.style.display="flex",n.style.height="100%",n.style.alignItems="center",n.style.justifyContent="center"}else if(e instanceof HTMLTemplateElement){const t=document.importNode(e.content,!0);n.appendChild(t)}else if(e instanceof HTMLElement)n.appendChild(e);else if("string"==typeof e)if(e.trim().startsWith("<template")){const t=document.createElement("template");t.innerHTML=e;const i=document.importNode(t.content,!0);n.appendChild(i)}else n.innerHTML=e}catch(e){console.error("Error setting empty content:",e),n.innerHTML="<div>No content available</div>"}}createToolbars(){this.MWCViewElements.toolbarContainer=document.createElement("div"),this.MWCViewElements.toolbarContainer.className="mwc-view-controls-container",this.config.container.appendChild(this.MWCViewElements.toolbarContainer),this.MWCViewElements.selectedToolbarContainer=document.createElement("div"),this.MWCViewElements.selectedToolbarContainer.className="mwc-view-controls-container",this.MWCViewElements.selectedToolbarContainer.style.display="none",this.config.container.appendChild(this.MWCViewElements.selectedToolbarContainer)}createToolbarButton(e){const n=document.createElement("div");if(n.className=`mwc-view-controls-btn ${(null==e?void 0:e.className)||""}`,!e)return n.classList.add("disabled"),n.innerHTML="<div></div>",n;const t=document.createElement("div");if(t.className="icon",(i=e.icon).trim().startsWith("<svg")&&i.trim().endsWith("</svg>"))t.innerHTML=e.icon;else{const n=document.createElement("img");n.src=e.icon,n.alt=e.label,n.width=24,n.height=24,t.appendChild(n)}var i;const a=document.createElement("div");return a.className="label",a.textContent=e.label,!0===e.isDisabled&&n.classList.add("disabled"),!0===e.isHidden&&n.classList.add("hide"),n.appendChild(t),n.appendChild(a),e.onClick&&n.addEventListener("click",e.onClick),n}setVisible(e,n){this.config.container.style.display=e?"flex":"none"}showContent(e){this.MWCViewElements.contentContainer.style.display=e?"flex":"none",this.MWCViewElements.emptyContentContainer.style.display=e?"none":"flex"}toggleSelectionMode(e){this.isSelectionMode=e,this.updateToolbarState()}updateToolbarState(){this.MWCViewElements.toolbarContainer.style.display=this.isSelectionMode?"none":"flex",this.MWCViewElements.selectedToolbarContainer.style.display=this.isSelectionMode?"flex":"none"}}const B="\n  .mwc-view-container {\n    display: flex;\n    flex-direction: column;\n    position: relative;\n    width: 100%;\n    height: 100%;\n    background-color: white;\n    font-family: Verdana;\n    color: black;\n  }\n\n  .mwc-view-container .mwc-view-header {\n    display: flex;\n    font-family: Verdana;\n    height: 3rem;\n    font-size: 24px;\n    align-items: center;\n    justify-content: center;\n    background-color: #e6e6e6;\n    flex: 0 1 3rem;\n    padding: 0.5rem;\n    user-select: none;\n        color: black;\n  }\n\n  .mwc-view-container .mwc-view-header .mwc-view-header-title {\n    white-space: nowrap;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    max-width: 100%;\n        color: black;\n  }\n\n  .mwc-library-header-btn:hover {\n    text-decoration: underline;\n  }\n\n  .mwc-view-container .mwc-view-content {\n    flex: 1 1 auto;\n    overflow-y: auto;\n    display: none;\n    flex-direction: column;\n    justify-content: start;\n    padding: 1rem;\n    gap: 1rem;\n    padding-bottom: 2rem;\n  }\n\n  .mwc-view-container .mwc-view-content-empty {\n    flex: 1 1 auto;\n    overflow-y: auto;\n    display: flex;\n    flex-direction: column;\n    align-items: center;\n    padding: 1rem;\n    user-select: none;\n    font-family: Verdana;\n  }\n\n  .mwc-view-container .mwc-view-content-empty {\n    flex: 1 1 auto;\n    overflow-y: auto;\n    display: flex;\n    flex-direction: column;\n    align-items: center;\n    padding: 1rem;\n    user-select: none;\n    font-family: Verdana;\n  }\n\n  .mwc-view-container .mwc-view-controls-container {\n    display: flex;\n    height: 6rem;\n    background-color: #323234;\n    align-items: center;\n    font-size: 12px;\n    font-family: Verdana;\n    color: white;\n    width: 100%;\n    flex: 0 1 65px;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn {\n    color: white;\n    cursor: pointer;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    flex-direction: column;\n    height: 100%;\n    width: 100%;\n    gap: 0.5rem;\n    text-align: center;\n    user-select: none;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn >div:first-child {\n    padding-top: 1rem;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn >div:last-child {\n    padding-bottom: 1rem;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn.selected{\n    background-color: #E36605;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn.disabled {\n    pointer-events: none;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn.disabled >div {\n    opacity: 0.4;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn.hide {\n    display: none;\n  }\n\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn .icon img,\n  .mwc-view-container .mwc-view-controls-container .mwc-view-controls-btn .icon svg {\n    width: 24px;\n    height: 24px;\n  }\n";class N{constructor(e){this.config=e,this.checked=!1,this.createUI(),this.bindEvents(),this.toggleCheck(!1)}createUI(){this.createStylesheet();const e=s.DDV.documentManager.getDocument(this.config.docId),n=e.pages.length;this.dom=document.createElement("div"),this.dom.className="mwc-document-item",this.dom.innerHTML=`\n      <div class="mwc-transfer-info-container">\n        <div class="mwc-transfer-thumbnail">\n          ${f.defaultDocument}\n        </div>\n        <div class="mwc-transfer-info">\n          <div class="mwc-transfer-name-container">\n            ${e.name}           \n          </div>\n          <div class="mwc-transfer-pages">${n} pages</div>\n        </div>\n      </div>\n      <div class="mwc-transfer-check-icon">\n        ${f.selectedCircle}\n      </div>\n    `,this.selectedIcon=this.dom.querySelector(".mwc-transfer-check-icon"),this.updateThumbnail(e)}createStylesheet(){const e=document.createElement("style");e.textContent=R,document.head.appendChild(e)}async updateThumbnail(e){const n=this.dom.querySelector(".mwc-transfer-thumbnail");if(n.textContent="",e.pages[0]){const t=await e.getPageData(e.pages[0]),i=URL.createObjectURL(t.display.data),a=document.createElement("img");a.className="mwc-image-thumbnail",a.alt="mwc-image-thumbnail",a.src=i,n.append(a)}else n.innerHTML=f.defaultDocument}bindEvents(){this.dom.addEventListener("click",(e=>{this.toggleCheck()}))}toggleCheck(e){var n,t;this.checked=null!=e?e:!this.checked,this.selectedIcon.style.display=this.checked?"flex":"none",this.dom.style.border=this.checked?"2px solid #FE8E14":"2px solid transparent",null===(t=(n=this.config).onCheckedChange)||void 0===t||t.call(n,this.config.docId,this.checked)}getDom(){return this.dom}dispose(){this.dom.remove()}}const R="\n.mwc-transfer-item {\n  display: grid;\n  grid-template-columns: 90% 10%;\n  background-color: #EFEFEF;\n  cursor: pointer;\n  font-family: Verdana;\n  padding: 15px;\n  align-items: center\n}\n\n.mwc-transfer-info-container {\n  display: flex;\n  align-items: center;\n  gap: 12px;\n}\n\n.mwc-transfer-info {\n  display: flex;\n  flex-direction: column;\n  gap: 12px;\n  padding-right: 1rem;\n  overflow: hidden;\n}\n\n.mwc-transfer-info .mwc-transfer-name-container  {\n  font-size: 16px;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n\n\n.mwc-transfer-info .mwc-transfer-pages {\n  color: #888888;\n}\n\n.mwc-transfer-thumbnail {\n  width: 70px;\n  height: 70px;\n  background-color: #DADCE0;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n}\n\n.mwc-transfer-thumbnail svg {\n  width: 48px;\n  height: 48px;\n  padding: 1rem;\n}\n\n.mwc-image-thumbnail {\n  width: 100%;\n  height: 100%;\n  object-fit: contain;\n}\n";var I;!function(e){e.Copy="copy",e.Move="move"}(I||(I={}));class U extends T{constructor(e){super(e),this.config=e,this.transferMode=I.Copy,this.checkedDocUids=[],this.docItems=[],this.toolbarBtn={action:null,cancel:null},this.headerTitle=null}initialize(){super.initialize(),D("mwc-transfer-view-style",_),this.updateEmptyContentHTML(),this.setVisible(!1)}createHeader(){super.createHeader(),this.MWCViewElements.headerContainer.innerHTML='\n      <div class="mwc-transfer-view-header-title">Transfer Page</div>\n    ',this.headerTitle=this.MWCViewElements.headerContainer.querySelector(".mwc-transfer-view-header-title")}createContent(){this.MWCViewElements.contentContainer=document.createElement("div"),this.MWCViewElements.contentContainer.className="mwc-view-content",this.config.container.appendChild(this.MWCViewElements.contentContainer)}updateEmptyContentHTML(){this.MWCViewElements.emptyContentContainer.innerHTML='\n      <div class="title">\n        No other documents to move the pages!\n      </div>\n      <div class="desc">\n        Please create another document!\n      </div>\n    '}createToolbars(){super.createToolbars();[{id:"mwc-transfer-cancel",icon:f.back,label:"Cancel",onClick:()=>this.handleCancelButton()},{id:"mwc-transfer-action",icon:f.done,label:"Action",className:"action-btn",onClick:()=>{}}].forEach((e=>{const n=this.createToolbarButton(e);"mwc-transfer-cancel"===e.id?this.toolbarBtn.cancel=n:"mwc-transfer-action"===e.id&&(this.toolbarBtn.action=n),this.MWCViewElements.toolbarContainer.appendChild(n)}))}updateHeaderAndAction(){switch(this.transferMode){case I.Copy:this.headerTitle.textContent="Copy Selected Pages to",this.toolbarBtn.action.children[1].textContent="Paste";break;case I.Move:this.headerTitle.textContent="Move Selected Pages to",this.toolbarBtn.action.children[1].textContent="Confirm"}}setVisible(e,n){if(super.setVisible(e),e&&n){this.MWCViewElements.contentContainer.textContent="",this.transferMode=n.mode,this.updateHeaderAndAction(),this.updateToolbarStyle(),this.toolbarBtn.action.onclick=()=>this.handleActionClick(n.docId,n.selectedIdx);const e=s.DDV.documentManager.getAllDocuments().filter((e=>this.transferMode!==I.Move||e.uid!==n.docId)),t=e.length>0;this.showContent(t),t&&this.loadDocuments(e)}}loadDocuments(e){e.forEach((e=>{const n=new N({docId:e.uid,onCheckedChange:(e,n)=>this.handleDocumentChecked(e,n)});this.docItems.unshift(n),this.MWCViewElements.contentContainer.firstChild?this.MWCViewElements.contentContainer.insertBefore(n.getDom(),this.MWCViewElements.contentContainer.firstChild):this.MWCViewElements.contentContainer.appendChild(n.getDom())}))}handleDocumentChecked(e,n){var t;n?this.checkedDocUids.push(e):this.checkedDocUids=null===(t=this.checkedDocUids)||void 0===t?void 0:t.filter((n=>n!==e)),this.updateToolbarStyle()}updateToolbarStyle(){const e=this.transferMode===I.Move?1!==this.checkedDocUids.length:this.checkedDocUids.length<1;this.toolbarBtn.action.classList.toggle("disabled",e)}handleCancelButton(){var e,n;this.checkedDocUids=[],this.docItems.forEach((e=>{e.toggleCheck(!1),e.dispose()})),this.docItems=[],null===(n=(e=this.config).onCancelTransfer)||void 0===n||n.call(e)}handleActionClick(e,n){var t,i;this.toolbarBtn.action.classList.contains("disabled")||(this.transferMode===I.Copy?this.checkedDocUids.forEach((t=>{s.DDV.documentManager.copyPagesToDocument(e,t,{sourceIndices:[...n]})})):this.transferMode===I.Move&&s.DDV.documentManager.movePagesToDocument(e,this.checkedDocUids[0],{sourceIndices:[...n]}),null===(i=(t=this.config).onConfirmTransfer)||void 0===i||i.call(t,this.transferMode),this.handleCancelButton())}dispose(){this.docItems.forEach((e=>e.dispose())),this.docItems=[],this.checkedDocUids=[],this.config.container&&(this.config.container.style.display="none")}}const _="\n  .mwc-view-controls-btn.action-btn .label {\n    color: #fe8e14;\n  }\n";class F extends T{constructor(e){super(e),this.config=e,this.documentTitle=null,this.headerRenameTitleBtn=null,this.toolbarBtn={backToLibrary:null,capture:null,import:null,shareDocument:null,uploadDocument:null,manage:null,copyTo:null,moveTo:null,deleteImage:null,shareImage:null,uploadImage:null,back:null},this.headerTitle=null,this.headerActionBtn={close:null,cancel:null,selectAll:null},this.browseViewer=null,this.isDragged=!1}bindBrowseViewerEvents(){this.browseViewer.on("selectedPagesChanged",(e=>{var n;if(!this.isSelectionMode)return;(null===(n=this.browseViewer)||void 0===n?void 0:n.currentDocument)&&this.handlePageChecked()})),this.browseViewer.on("click",(e=>{if(!this.isSelectionMode){if(!b()&&this.isDragged)return void(this.isDragged=!1);if(e.index>-1){const n=this.browseViewer.currentDocument;this.config.onPageClick&&this.config.onPageClick(n.uid,e.index)}}})),this.browseViewer.on("pagesDragged",(()=>{this.isDragged=!0}))}initialize(){D("mwc-document-view-style",W),super.initialize(),this.createBrowseViewer(),this.bindBrowseViewerEvents(),this.updateEmptyContentHTML(),this.setVisible(!1)}setVisible(e){super.setVisible(e);const n=this.browseViewer.currentDocument;if(e){const e=n&&n.pages.length>0;this.updateHeaderActionBtnStyle(),this.showContent(e),this.updateToolbarBtnStates()}}createBrowseViewer(){var e;this.browseViewer=new s.DDV.BrowseViewer({container:this.MWCViewElements.contentContainer,uiConfig:{type:s.DDV.Elements.Layout,style:{border:"none"},children:[s.DDV.Elements.MainView]},groupUid:null===(e=this.config)||void 0===e?void 0:e.groupUid,viewerConfig:{canvasStyle:{background:"white"},checkboxStyle:{borderRadius:"1px",left:"6px",top:"6px",width:"24px",height:"24px",visibility:"hidden"},currentPageStyle:{border:"2px solid #FE8E14"},pageStyle:{background:"#e6e6e6"}}}),this.browseViewer.setRowAndColumn(2,2)}createHeader(){var e;super.createHeader(),this.MWCViewElements.headerContainer.innerHTML=`\n    <div class="mwc-document-view-header">\n      <div class="mwc-document-view-header-container">\n        <div class="mwc-document-view-header-doc-name">Document Name</div>\n        <button type="button" class="mwc-document-view-header-btn rename">\n          ${f.edit}\n        </button>\n      </div>\n      <div class="mwc-document-view-header-actions">\n        <button type="button" class="mwc-document-view-header-btn selectAll">Select All</button>\n        <button type="button" class="mwc-document-view-header-btn cancel">Cancel</button>\n        <button type="button" class="mwc-document-view-header-btn close" style="display: ${this.config.showLibraryView?"none":"flex"}">\n          ${f.close}\n        </button>\n      </div>\n    </div>\n    `,this.documentTitle=this.MWCViewElements.headerContainer.querySelector(".mwc-document-view-header-doc-name"),this.headerRenameTitleBtn=this.MWCViewElements.headerContainer.querySelector(".mwc-document-view-header-btn.rename"),null===(e=this.headerRenameTitleBtn)||void 0===e||e.addEventListener("click",(()=>this.handleRename())),this.headerActionBtn.close=this.MWCViewElements.headerContainer.querySelector(".close"),this.headerActionBtn.close.addEventListener("click",(()=>this.handleClose())),this.headerActionBtn.selectAll=this.MWCViewElements.headerContainer.querySelector(".selectAll"),this.headerActionBtn.selectAll.addEventListener("click",(()=>this.handleSelectAll())),this.headerActionBtn.cancel=this.MWCViewElements.headerContainer.querySelector(".cancel"),this.headerActionBtn.cancel.addEventListener("click",(()=>this.handleSelectAll())),this.updateHeaderActionBtnStyle()}updateHeaderActionBtnStyle(){if(this.isSelectionMode){this.documentTitle.textContent="Select Pages",this.headerRenameTitleBtn.style.display="none",this.headerActionBtn.close.style.display="none";const e=this.browseViewer.getSelectedPageIndices().length===this.browseViewer.currentDocument.pages.length;this.headerActionBtn.selectAll.style.display=e?"none":"flex",this.headerActionBtn.cancel.style.display=e?"flex":"none"}else this.updateHeaderTitle(),this.headerRenameTitleBtn.style.display="flex",this.headerActionBtn.close.style.display=this.config.showLibraryView?"none":"flex",this.headerActionBtn.selectAll.style.display="none",this.headerActionBtn.cancel.style.display="none"}updateHeaderTitle(){var e;const n=null===(e=this.browseViewer)||void 0===e?void 0:e.currentDocument;this.documentTitle.textContent=(null==n?void 0:n.name)||"Document Name"}async handleRename(){const e=this.browseViewer.currentDocument;if(!e)return;const n=await L({container:this.config.container,type:M.INPUT,title:"Rename Document",placeholder:"Enter document name",initialValue:e.name,confirmText:"Rename",validation:e=>e.length<1?"Name can't be empty":null});n&&(e.rename(n),this.updateHeaderTitle(),await A(this.config.container,"Renamed"))}dispose(){var e;null===(e=this.browseViewer)||void 0===e||e.destroy(),this.browseViewer=null,s.DDV.documentManager.deleteAllDocuments(),this.config.container&&(this.config.container.style.display="none")}handleClose(){var e;if(!this.config.showLibraryView)try{null===(e=this.config)||void 0===e||e.onClose()}catch(e){console.error("Failed to close library view:",e)}}updateEmptyContentHTML(){const e=`\n    <div class="mwc-default-empty-document">\n      ${f.emptyLibrary}\n      <div class="title">Add your first page!</div>\n      <div class="desc">\n        <div>Option 1: Click "<b>Capture</b>" for live images</div>\n        <div>Option 2: Click "<b>Import</b>" for existing images</div>\n      </div>\n    </div>`;super.setEmptyContent(this.config.emptyContentConfig||e)}createToolbars(){var e,n,t,i,a,o,l,s,c,d,r,h,m,u,p,v,w,g,b,y,C,D,V,x,k,P,M,E,S,A,L,H,T,B,N,R,U,_,W,$,O,G,Z,z,q,j,X,Y,J;super.createToolbars();const{toolbarButtonsConfig:K,exportConfig:Q,showLibraryView:ee}=this.config,ne=!!(null==Q?void 0:Q.uploadToServer),te=new File([""],"test.pdf",{type:"application/pdf"}),ie="share"in navigator&&navigator.canShare({files:[te]}),ae=()=>{ie?this.handleShareDoc():F.handleDownloadDoc(this.browseViewer.currentDocument,this.config.container)},oe=()=>{ie?this.handleShareImage():this.handleDownloadImage()};[{id:"mwc-document-backToLibrary",icon:null!==(n=null===(e=null==K?void 0:K.backToLibrary)||void 0===e?void 0:e.icon)&&void 0!==n?n:f.back,label:(null===(t=null==K?void 0:K.backToLibrary)||void 0===t?void 0:t.label)||"Back",isHidden:(null===(i=null==K?void 0:K.backToLibrary)||void 0===i?void 0:i.isHidden)||!this.config.showLibraryView||!1,className:`${(null===(a=null==K?void 0:K.backToLibrary)||void 0===a?void 0:a.className)||""}`,onClick:()=>{var e,n;return null===(n=(e=this.config).onBackToLibrary)||void 0===n?void 0:n.call(e)}},{id:"mwc-document-capture",icon:(null===(o=null==K?void 0:K.capture)||void 0===o?void 0:o.icon)||f.cameraCapture,label:(null===(l=null==K?void 0:K.capture)||void 0===l?void 0:l.label)||"Capture",isHidden:(null===(s=null==K?void 0:K.capture)||void 0===s?void 0:s.isHidden)||!1,className:`${(null===(c=null==K?void 0:K.capture)||void 0===c?void 0:c.className)||""}`,onClick:()=>{var e,n;return null===(n=(e=this.config).onCameraCapture)||void 0===n?void 0:n.call(e)}},{id:"mwc-document-import",icon:(null===(d=null==K?void 0:K.import)||void 0===d?void 0:d.icon)||f.galleryImport,label:(null===(r=null==K?void 0:K.import)||void 0===r?void 0:r.label)||"Import",isHidden:(null===(h=null==K?void 0:K.import)||void 0===h?void 0:h.isHidden)||!1,className:`${(null===(m=null==K?void 0:K.import)||void 0===m?void 0:m.className)||""}`,onClick:()=>{var e,n;return null===(n=(e=this.config).onGalleryImport)||void 0===n?void 0:n.call(e)}},{id:"mwc-document-shareDocument",icon:(null===(u=null==K?void 0:K.shareDocument)||void 0===u?void 0:u.icon)||(ie?f.sharePDF:f.downloadPDF),label:(null===(p=null==K?void 0:K.shareDocument)||void 0===p?void 0:p.label)||(ie?"Share":"Download"),className:`${(null===(v=null==K?void 0:K.shareDocument)||void 0===v?void 0:v.className)||""}`,isHidden:(null===(w=null==K?void 0:K.shareDocument)||void 0===w?void 0:w.isHidden)||!1,onClick:()=>ae()},{id:"mwc-document-uploadDocument",icon:(null===(g=null==K?void 0:K.uploadDocument)||void 0===g?void 0:g.icon)||f.uploadPDF,label:(null===(b=null==K?void 0:K.uploadDocument)||void 0===b?void 0:b.label)||"Upload",className:`${(null===(y=null==K?void 0:K.uploadDocument)||void 0===y?void 0:y.className)||""}`,isHidden:(null===(C=null==K?void 0:K.uploadDocument)||void 0===C?void 0:C.isHidden)||!ne,onClick:()=>this.handleUploadDocument()},{id:"mwc-document-manage",icon:(null===(D=null==K?void 0:K.manage)||void 0===D?void 0:D.icon)||f.fileOperations,label:(null===(V=null==K?void 0:K.manage)||void 0===V?void 0:V.label)||"Manage",isHidden:(null===(x=null==K?void 0:K.manage)||void 0===x?void 0:x.isHidden)||!1,className:`${(null===(k=null==K?void 0:K.manage)||void 0===k?void 0:k.className)||""}`,onClick:()=>this.handleManagePages()}].forEach((e=>{const n=this.createToolbarButton(e);this.toolbarBtn[`${e.id.split("-").pop()}`]=n,this.MWCViewElements.toolbarContainer.appendChild(n)}));[{id:"mwc-document-select-copyTo",icon:(null===(P=null==K?void 0:K.copyTo)||void 0===P?void 0:P.icon)||f.copyTo,label:(null===(M=null==K?void 0:K.copyTo)||void 0===M?void 0:M.label)||"Copy To",className:`selected ${(null===(E=null==K?void 0:K.copyTo)||void 0===E?void 0:E.className)||""}`,isHidden:(null===(S=null==K?void 0:K.copyTo)||void 0===S?void 0:S.isHidden)||!ee,onClick:()=>this.handleTransferPage(I.Copy)},{id:"mwc-document-select-moveTo",icon:(null===(A=null==K?void 0:K.moveTo)||void 0===A?void 0:A.icon)||f.moveTo,label:(null===(L=null==K?void 0:K.moveTo)||void 0===L?void 0:L.label)||"Move To",className:`selected ${(null===(H=null==K?void 0:K.moveTo)||void 0===H?void 0:H.className)||""}`,isHidden:(null===(T=null==K?void 0:K.moveTo)||void 0===T?void 0:T.isHidden)||!ee,onClick:()=>this.handleTransferPage(I.Move)},{id:"mwc-library-select-deleteImage",icon:(null===(B=null==K?void 0:K.deleteImage)||void 0===B?void 0:B.icon)||f.delete,label:(null===(N=null==K?void 0:K.deleteImage)||void 0===N?void 0:N.label)||"Delete",className:`selected ${(null===(R=null==K?void 0:K.deleteImage)||void 0===R?void 0:R.className)||""}`,isHidden:null===(U=null==K?void 0:K.deleteImage)||void 0===U?void 0:U.isHidden,onClick:()=>this.handleDeleteImage()},{id:"mwc-document-select-shareImage",icon:(null===(_=null==K?void 0:K.shareImage)||void 0===_?void 0:_.icon)||(ie?f.sharePNG:f.downloadPNG),label:(null===(W=null==K?void 0:K.shareImage)||void 0===W?void 0:W.label)||(ie?"Share":"Download"),isHidden:null===($=null==K?void 0:K.shareImage)||void 0===$?void 0:$.isHidden,className:`selected ${(null===(O=null==K?void 0:K.shareImage)||void 0===O?void 0:O.className)||""}`,onClick:()=>oe()},{id:"mwc-document-uploadImage",icon:(null===(G=null==K?void 0:K.uploadImage)||void 0===G?void 0:G.icon)||f.uploadPNG,label:(null===(Z=null==K?void 0:K.uploadImage)||void 0===Z?void 0:Z.label)||"Upload",className:`selected ${(null===(z=null==K?void 0:K.uploadImage)||void 0===z?void 0:z.className)||""}`,isHidden:(null===(q=null==K?void 0:K.uploadImage)||void 0===q?void 0:q.isHidden)||!ne,onClick:()=>this.handleUploadImage()},{id:"mwc-library-select-back",icon:(null===(j=null==K?void 0:K.back)||void 0===j?void 0:j.icon)||f.back,label:(null===(X=null==K?void 0:K.back)||void 0===X?void 0:X.label)||"Back",className:`selected ${(null===(Y=null==K?void 0:K.back)||void 0===Y?void 0:Y.className)||""}`,isHidden:null===(J=null==K?void 0:K.back)||void 0===J?void 0:J.isHidden,onClick:()=>this.handleSelectedBack()}].forEach((e=>{const n=this.createToolbarButton(e);this.toolbarBtn[`${e.id.split("-").pop()}`]=n,this.MWCViewElements.selectedToolbarContainer.appendChild(n)}))}async handleShareDoc(){const e=[],n=this.browseViewer.currentDocument;if(n.pages.length){const t=await n.saveToPdf({mimeType:"application/octet-stream",saveAnnotation:"annotation",quality:100});e.push(new File([t],`${n.name}.pdf`,{type:"application/pdf"}))}if(navigator.canShare&&navigator.canShare({files:e}))try{await navigator.share({files:e,title:"PDF Files"})}catch(e){"AbortError"!==e.name&&await A(this.config.container,"Failed to share files",E.ERROR)}else await A(this.config.container,"Your system doesn't support sharing PDF files",E.WARNING)}static async handleDownloadDoc(e,n){var t;(null===(t=null==e?void 0:e.pages)||void 0===t?void 0:t.length)?e.saveToPdf({mimeType:"application/octet-stream",saveAnnotation:"annotation",quality:100}).then((n=>{const t=URL.createObjectURL(n),i=document.createElement("a");i.href=t,i.download=`${e.name}.pdf`,i.click(),i.remove()})):(console.warn("Failed to download. Document contains no pages"),await A(n,"Document contains no pages!",E.WARNING))}async handleUploadDocument(){var e,n,t,i,a,o,l,s,c,d;if(null===(n=null===(e=this.config)||void 0===e?void 0:e.exportConfig)||void 0===n?void 0:n.uploadToServer)try{const e=this.browseViewer.currentDocument;if(null===(t=null==e?void 0:e.pages)||void 0===t?void 0:t.length){const n=await e.saveToPdf({mimeType:"application/pdf",saveAnnotation:"annotation",quality:100}),t=`${e.name}.pdf`,r=await(null===(a=null===(i=this.config)||void 0===i?void 0:i.exportConfig)||void 0===a?void 0:a.uploadToServer(t,n));if("success"===(null==r?void 0:r.status)){const e=this.config.getUploadedDocuments();e.push(r),this.config.updateUploadedDocuments(e);if(await(null===(l=null===(o=this.config.exportConfig)||void 0===o?void 0:o.onUploadSuccess)||void 0===l?void 0:l.call(o,t,"pdf",k.Page,n)))return void(null===(s=this.config)||void 0===s||s.onClose());await L({container:this.config.container,type:M.CONFIRM,variant:E.SUCCESS,title:"Upload Successful",confirmText:"View in Uploads",cancelText:"Continue"})&&(null===(d=(c=this.config).onViewUploadsHistory)||void 0===d||d.call(c))}}else console.warn(`Upload failed: ${e.name} contains no pages`),await A(this.config.container,"Document contains no pages!",E.WARNING)}catch(e){let n=(null==e?void 0:e.message)||e;console.error("Upload failed:",n),await A(this.config.container,"Upload Failed!",E.ERROR)}else console.warn("No upload function configured")}handleManagePages(){this.toggleSelectionMode(!0)}handleSelectAll(){this.browseViewer.getSelectedPageIndices().length===this.browseViewer.currentDocument.pages.length?this.browseViewer.selectPages([]):this.browseViewer.selectAllPages(),this.updateToolbarBtnStates()}toggleSelectionMode(e){if(this.isSelectionMode!==e){if(super.toggleSelectionMode(e),this.browseViewer.multiselectMode=e,this.updateHeaderActionBtnStyle(),e){const e=this.browseViewer.getCurrentPageIndex();e>=0&&this.browseViewer.selectPages([e])}else this.browseViewer.selectPages([]);this.browseViewer.updateStyle("checkboxStyle",{visibility:e?"visible":"hidden",border:"1px solid #707070"})}}handlePageChecked(){this.updateToolbarBtnStates(),this.updateHeaderActionBtnStyle()}updateToolbarBtnStates(){var e;const n=this.browseViewer.currentDocument,t=!(null===(e=null==n?void 0:n.pages)||void 0===e?void 0:e.length),i=this.browseViewer.getSelectedPageIndices().length>0;this.browseViewer.getSelectedPageIndices().length,this.browseViewer.currentDocument.pages.length,this.toolbarBtn.manage.classList.toggle("disabled",t),this.toolbarBtn.shareDocument.classList.toggle("disabled",t),this.toolbarBtn.uploadDocument.classList.toggle("disabled",t),this.toolbarBtn.copyTo.classList.toggle("disabled",!i),this.toolbarBtn.moveTo.classList.toggle("disabled",!i),this.toolbarBtn.shareImage.classList.toggle("disabled",!i),this.toolbarBtn.deleteImage.classList.toggle("disabled",!i),this.toolbarBtn.uploadImage.classList.toggle("disabled",!i)}handleTransferPage(e){if(e===I.Copy&&this.toolbarBtn.copyTo.classList.contains("disabled"))return;if(e===I.Move&&this.toolbarBtn.moveTo.classList.contains("disabled"))return;const n=this.browseViewer.currentDocument,t=this.browseViewer.getSelectedPageIndices();this.config.onTransferPages(e,n.uid,t)}async handleDeleteImage(){if(this.toolbarBtn.deleteImage.classList.contains("disabled"))return;const e=this.browseViewer.getSelectedPageIndices();if(e.length>0){await L({container:this.config.container,type:M.CONFIRM,variant:E.WARNING,title:"Delete Pages",message:`Are you sure you want to delete ${1===e.length?"1 page":`${e.length} pages`}?`,confirmText:"Delete",cancelText:"Cancel",showCloseBtn:!0})&&(this.browseViewer.currentDocument.deletePages(e),this.showContent(0!==this.browseViewer.currentDocument.pages.length),this.updateToolbarBtnStates(),this.handleSelectedBack(),await A(this.config.container,"Deleted",E.SUCCESS))}}async handleShareImage(){try{const e=this.browseViewer.currentDocument,n=this.browseViewer.getSelectedPageIndices(),t=(await Promise.all(n.map((n=>e.saveToPng(n,{saveAnnotation:!0}))))).map(((t,i)=>new File([t],`${e.name}-${n[i]}-${Date.now()}.png`,{type:t.type})));if(navigator.canShare&&navigator.canShare({files:t}))try{await navigator.share({files:t,title:"Image Files"})}catch(e){"AbortError"!==e.name&&await A(this.config.container,"Failed to share files",E.ERROR)}else await A(this.config.container,"Failed to share",E.WARNING)}catch(e){await A(this.config.container,"Error processing files",E.ERROR)}}async handleDownloadImage(){const e=this.browseViewer.currentDocument,n=this.browseViewer.getSelectedPageIndices();try{n.forEach((async(t,i)=>{const a=await e.saveToPng(t,{saveAnnotation:!0}),o=URL.createObjectURL(a),l=document.createElement("a");l.href=o,l.download=`${e.name}-${n[i]}-${Date.now()}.png`,l.click(),l.remove(),URL.revokeObjectURL(o)})),await A(this.config.container,"Downloaded",E.SUCCESS)}catch(e){const n=(null==e?void 0:e.message)||e;console.warn("Download failed:",n),await A(this.config.container,"Failed to download page",E.ERROR)}}async handleUploadImage(){var e,n,t,i;if(null===(n=null===(e=this.config)||void 0===e?void 0:e.exportConfig)||void 0===n?void 0:n.uploadToServer)try{const e=this.browseViewer.currentDocument,n=this.browseViewer.getSelectedPageIndices(),a=n.map((async(t,i)=>{var a,o,l,s,c;const d=await e.saveToPng(t,{saveAnnotation:!0}),r=`${e.name}-${n[i]}-${Date.now()}.png`,h=new Blob([d],{type:"image/png"}),m=await(null===(o=null===(a=this.config)||void 0===a?void 0:a.exportConfig)||void 0===o?void 0:o.uploadToServer(r,h));if("success"===(null==m?void 0:m.status)){const e=this.config.getUploadedDocuments();e.push(m),this.config.updateUploadedDocuments(e);if(await(null===(s=null===(l=this.config.exportConfig)||void 0===l?void 0:l.onUploadSuccess)||void 0===s?void 0:s.call(l,r,"png",k.Document,h)))return void(null===(c=this.config)||void 0===c||c.onClose())}return m})),o=await Promise.all(a);if((null==o?void 0:o.filter((e=>"success"===(null==e?void 0:e.status)))).length){await L({container:this.config.container,type:M.CONFIRM,variant:E.SUCCESS,title:"Upload Successful",confirmText:"View in Uploads",cancelText:"Continue"})&&(null===(i=(t=this.config).onViewUploadsHistory)||void 0===i||i.call(t))}}catch(e){let n=(null==e?void 0:e.message)||e;console.error("Upload failed:",n),await A(this.config.container,"Upload Failed!",E.ERROR)}else console.warn("No upload function configured")}handleSelectedBack(){this.toggleSelectionMode(!1)}}const W="\n  .mwc-document-view-header {\n    display: flex;\n    justify-content: space-between;\n    align-items: center;\n    width: 100%;\n    color: black;\n  }\n\n  .mwc-document-view-header-btn {\n    border: none;\n    background: transparent;\n    display: flex;\n    align-content: center;\n    cursor: pointer;\n  }\n\n  .mwc-document-view-header-btn.rename{\n    width: 30px;\n    height: 30px;\n  }\n\n  .mwc-document-view-header-container {\n    display: flex;\n    align-items: center;\n    gap: 8px;\n    flex: 1;\n    max-width: calc(100% - 4rem);\n    padding-left: 1rem;\n  }\n\n  .mwc-document-view-header-container .mwc-document-view-header-doc-name {\n    font-family: Verdana;\n    font-size: 18px;\n    white-space: nowrap;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    user-select: none;\n  }\n\n  .mwc-document-view-header-actions {\n    display: flex;\n    align-items: center;\n    padding-right: 1rem;\n  }\n\n  .mwc-document-view-header-actions .mwc-document-view-header-btn.selectAll,\n  .mwc-document-view-header-actions .mwc-document-view-header-btn.cancel {\n    background: none;\n    border: none;\n    color: #FE8E14;\n    font-size: 14px;\n    cursor: pointer;\n    padding: 4px 8px;\n    align-content: end;\n  }\n\n  .mwc-default-empty-document {\n    display: flex;\n    flex-direction: column;\n    justify-content:center;\n    align-items: center;\n    gap: 1rem;\n  }\n\n  .mwc-default-empty-document svg {\n    width: 200px;\n    height: auto;\n  }\n\n  .mwc-default-empty-document .title {\n    margin-top: 2rem;\n    font-size: 24px;\n    color: black;\n  }\n\n  .mwc-default-empty-document .desc {\n    font-size: 16px;\n    color: black;\n  }\n";class $ extends T{constructor(e){super(e),this.config=e,this.headerTitle=null,this.headerActionBtn={close:null,cancel:null,selectAll:null},this.toolbarBtn={newDoc:null,capture:null,import:null,uploads:null,delete:null,print:null,share:null,upload:null,back:null},this.checkedDocUids=[],this.docItems=[]}bindDocumentManagerEvents(){s.DDV.documentManager.on("documentCreated",(e=>{const n=new V({docId:e.docUid,onCheckedChange:()=>this.handleDocumentChecked(),onDocumentClick:e=>{this.isSelectionMode||this.handleDocumentClick(e)},onRename:e=>this.handleRename(e)});this.docItems.unshift(n),this.MWCViewElements.contentContainer.firstChild?this.MWCViewElements.contentContainer.insertBefore(n.getDom(),this.MWCViewElements.contentContainer.firstChild):this.MWCViewElements.contentContainer.appendChild(n.getDom())})),s.DDV.documentManager.on("documentDeleted",(e=>{this.docItems.forEach(((n,t)=>{n.getUid()===e.docUid&&(n.dispose(),this.docItems.splice(t,1))}))}))}initialize(){D("mwc-library-view-style",O),super.initialize(),this.bindDocumentManagerEvents(),this.updateEmptyContentHTML(),this.setVisible(!1)}setVisible(e){if(super.setVisible(e),this.updateToolbarState(),e&&e){const e=s.DDV.documentManager.getAllDocuments().length;this.showContent(!!e),e&&this.docItems.forEach((e=>{e.update()}))}}createHeader(){super.createHeader(),this.MWCViewElements.headerContainer.innerHTML=`\n      <div class="mwc-view-header-title">Library</div>\n      <div class="mwc-view-header-actions">\n        <button type="button" class="mwc-library-header-btn selectAll">Select All</button>\n        <button type="button" class="mwc-library-header-btn cancel">Cancel</button>\n        <button type="button" class="mwc-library-header-btn close">\n          ${f.close}\n        </button>\n      </div>\n    `,this.headerTitle=this.MWCViewElements.headerContainer.querySelector(".mwc-view-header-title"),this.headerActionBtn.close=this.MWCViewElements.headerContainer.querySelector(".close"),this.headerActionBtn.close.addEventListener("click",(()=>this.handleClose())),this.headerActionBtn.cancel=this.MWCViewElements.headerContainer.querySelector(".cancel"),this.headerActionBtn.cancel.addEventListener("click",(()=>this.handleSelectAllOrCancel(!0))),this.headerActionBtn.selectAll=this.MWCViewElements.headerContainer.querySelector(".selectAll"),this.headerActionBtn.selectAll.addEventListener("click",(()=>this.handleSelectAllOrCancel(!1))),this.updateHeaderActionBtnStyle()}updateHeaderActionBtnStyle(){if(this.isSelectionMode){this.headerTitle.textContent="Select Items",this.headerActionBtn.close.style.display="none";const e=this.docItems.every((e=>e.checked));this.headerActionBtn.selectAll.style.display=e?"none":"flex",this.headerActionBtn.cancel.style.display=e?"flex":"none"}else this.headerTitle.textContent="Library",this.headerActionBtn.close.style.display="block",this.headerActionBtn.selectAll.style.display="none",this.headerActionBtn.cancel.style.display="none"}updateEmptyContentHTML(){const e=`\n    <div class="mwc-default-empty-library">\n      ${f.emptyLibrary}\n      <div class="title">\n        Create your first document!\n      </div>\n      <div class="desc">\n        <div>\n          Option 1: Click "<b>New</b>" to create a blank document\n        </div>\n        <div>\n          Option 2: Click "<b>Capture</b>" or "<b>Import</b>" to use images\n        </div>\n      </div>\n    </div>\n    `;super.setEmptyContent(this.config.emptyContentConfig||e)}handleClose(){try{this.config.onClose()}catch(e){console.error("Failed to close library view:",e)}}dispose(){this.docItems.forEach((e=>e.dispose())),this.docItems=[],s.DDV.documentManager.deleteAllDocuments()}toggleSelectionMode(e){this.isSelectionMode!==e&&(super.toggleSelectionMode(e),this.updateHeaderActionBtnStyle(),this.docItems.forEach((e=>e.setSelectMode(this.isSelectionMode))))}handleSelectAllOrCancel(e){if(e)return this.docItems.forEach((e=>e.toggleCheck(!1))),this.checkedDocUids=[],void this.toggleSelectionMode(!1);this.docItems.forEach((e=>{e.toggleCheck(!0)})),this.updateHeaderActionBtnStyle()}handleDocumentChecked(){var e,n,t;this.checkedDocUids=this.docItems.filter((e=>e.checked)).map((e=>e.getUid()));const i=this.checkedDocUids.length>0;this.toggleSelectionMode(i),this.updateHeaderActionBtnStyle();const a=this.checkedDocUids.some((e=>{var n;const t=s.DDV.documentManager.getDocument(e);return!(null===(n=null==t?void 0:t.pages)||void 0===n?void 0:n.length)})),o=1===this.checkedDocUids.length;null===(e=this.toolbarBtn.print)||void 0===e||e.classList.toggle("disabled",!o||a),null===(n=this.toolbarBtn.upload)||void 0===n||n.classList.toggle("disabled",a),null===(t=this.toolbarBtn.share)||void 0===t||t.classList.toggle("disabled",a)}handleDocumentClick(e){var n,t;null===(t=(n=this.config).onDocumentClick)||void 0===t||t.call(n,e)}handleRename(e){const n=s.DDV.documentManager.getDocument(e);n&&L({container:this.config.container,type:M.INPUT,title:"Rename Document",placeholder:"Enter document name",initialValue:n.name,confirmText:"Rename",validation:e=>e.length<1?"Name can't be empty":null}).then((async t=>{if(t){n.rename(t);const i=this.docItems.find((n=>n.getUid()===e));null==i||i.update(),await A(this.config.container,"Renamed",E.SUCCESS)}}))}createToolbars(){var e,n,t,i,a,o,l,s,c,d,r,h,m,u,p,v,w,g,b,y,C,D,V,x,k,P,M,E,S,A,L,H,T,B,N,R;super.createToolbars();const{toolbarButtonsConfig:I,exportConfig:U}=this.config,_=new File([""],"test.pdf",{type:"application/pdf"}),F="share"in navigator&&navigator.canShare({files:[_]}),W=()=>{F?this.handleShare():this.handleDownload()},$=!!(null==U?void 0:U.uploadToServer);[{id:"mwc-lbrary-newDoc",icon:(null===(e=null==I?void 0:I.newDoc)||void 0===e?void 0:e.icon)||f.newDoc,label:(null===(n=null==I?void 0:I.newDoc)||void 0===n?void 0:n.label)||"New",className:(null===(t=null==I?void 0:I.newDoc)||void 0===t?void 0:t.className)||"",isHidden:null===(i=null==I?void 0:I.newDoc)||void 0===i?void 0:i.isHidden,onClick:()=>this.handleNewDocument()},{id:"mwc-lbrary-capture",icon:(null===(a=null==I?void 0:I.capture)||void 0===a?void 0:a.icon)||f.cameraCapture,label:(null===(o=null==I?void 0:I.capture)||void 0===o?void 0:o.label)||"Capture",className:(null===(l=null==I?void 0:I.capture)||void 0===l?void 0:l.className)||"",isHidden:null===(s=null==I?void 0:I.capture)||void 0===s?void 0:s.isHidden,onClick:()=>this.handleCameraCapture()},{id:"mwc-lbrary-import",icon:(null===(c=null==I?void 0:I.import)||void 0===c?void 0:c.icon)||f.galleryImport,label:(null===(d=null==I?void 0:I.import)||void 0===d?void 0:d.label)||"Import",className:(null===(r=null==I?void 0:I.import)||void 0===r?void 0:r.className)||"",isHidden:null===(h=null==I?void 0:I.import)||void 0===h?void 0:h.isHidden,onClick:()=>this.handleGalleryImport()},{id:"mwc-lbrary-uploads",icon:(null===(m=null==I?void 0:I.uploads)||void 0===m?void 0:m.icon)||f.uploadedFiles,label:(null===(u=null==I?void 0:I.uploads)||void 0===u?void 0:u.label)||"Uploads",className:(null===(p=null==I?void 0:I.uploads)||void 0===p?void 0:p.className)||"",isHidden:(null===(v=null==I?void 0:I.uploads)||void 0===v?void 0:v.isHidden)||!$,onClick:()=>this.handleViewUploadsHistory()}].forEach((e=>{const n=this.createToolbarButton(e);this.toolbarBtn[`${e.id.split("-").pop()}`]=n,this.MWCViewElements.toolbarContainer.appendChild(n)}));[{id:"mwc-library-select-delete",icon:(null===(w=null==I?void 0:I.delete)||void 0===w?void 0:w.icon)||f.delete,label:(null===(g=null==I?void 0:I.delete)||void 0===g?void 0:g.label)||"Delete",className:`selected ${(null===(b=null==I?void 0:I.delete)||void 0===b?void 0:b.className)||""}`,isHidden:null===(y=null==I?void 0:I.delete)||void 0===y?void 0:y.isHidden,onClick:()=>this.handleDelete()},{id:"mwc-library-select-print",icon:(null===(C=null==I?void 0:I.print)||void 0===C?void 0:C.icon)||f.print,label:(null===(D=null==I?void 0:I.print)||void 0===D?void 0:D.label)||"Print",className:`selected ${(null===(V=null==I?void 0:I.print)||void 0===V?void 0:V.className)||""}`,isHidden:null===(x=null==I?void 0:I.print)||void 0===x?void 0:x.isHidden,onClick:()=>this.handlePrint()},{id:"mwc-library-select-share",icon:(null===(k=null==I?void 0:I.share)||void 0===k?void 0:k.icon)||(F?f.sharePDF:f.downloadPDF),label:(null===(P=null==I?void 0:I.share)||void 0===P?void 0:P.label)||(F?"Share":"Download"),className:`selected ${(null===(M=null==I?void 0:I.share)||void 0===M?void 0:M.className)||""}`,isHidden:null===(E=null==I?void 0:I.share)||void 0===E?void 0:E.isHidden,onClick:()=>W()},{id:"mwc-library-select-upload",icon:(null===(S=null==I?void 0:I.upload)||void 0===S?void 0:S.icon)||f.uploadPDF,label:(null===(A=null==I?void 0:I.upload)||void 0===A?void 0:A.label)||"Upload",className:`selected ${(null===(L=null==I?void 0:I.upload)||void 0===L?void 0:L.className)||""}`,isHidden:(null===(H=null==I?void 0:I.upload)||void 0===H?void 0:H.isHidden)||!$,onClick:()=>this.handleUploadDocuments()},{id:"mwc-library-select-back",icon:(null===(T=null==I?void 0:I.back)||void 0===T?void 0:T.icon)||f.back,label:(null===(B=null==I?void 0:I.back)||void 0===B?void 0:B.label)||"Back",className:`selected ${(null===(N=null==I?void 0:I.back)||void 0===N?void 0:N.className)||""}`,isHidden:null===(R=null==I?void 0:I.back)||void 0===R?void 0:R.isHidden,onClick:()=>this.handleSelectedBack()}].forEach((e=>{const n=this.createToolbarButton(e);this.toolbarBtn[`${e.id.split("-").pop()}`]=n,this.MWCViewElements.selectedToolbarContainer.appendChild(n)}))}async handleNewDocument(){const e=await L({container:this.config.container,type:M.INPUT,title:"New Document",placeholder:"Enter document name",confirmText:"Create"});if(e){await this.createAndLoadDocument(e||`Doc-${Date.now()}`)&&(this.setVisible(!0),await A(this.config.container,"Created",E.SUCCESS))}}async createAndLoadDocument(e,n){try{const t=s.DDV.documentManager.createDocument({name:e||`Doc-${Date.now()}`});return n&&await t.loadSource(n),t}catch(e){let n=e.message||e;alert(`Failed to create and load document: ${n}`),console.error("Failed to create and load document: ",n)}}async handleCameraCapture(){await this.config.onCameraCapture()}async handleGalleryImport(){await this.config.onGalleryImport()}async handleViewUploadsHistory(){var e;null===(e=this.config)||void 0===e||e.onViewUploadsHistory()}async handleDelete(){await L({container:this.config.container,type:M.CONFIRM,variant:E.WARNING,title:"Delete Documents",message:`Are you sure you want to delete ${this.checkedDocUids.length} document(s)?`,confirmText:"Delete",cancelText:"Cancel",showCloseBtn:!0})&&(s.DDV.documentManager.deleteDocuments([...this.checkedDocUids]),this.setVisible(!0),this.toggleSelectionMode(!1),await A(this.config.container,"Deleted",E.SUCCESS))}async handlePrint(){var e,n;if(this.checkedDocUids.length>1||(null===(e=this.toolbarBtn.print)||void 0===e?void 0:e.classList.contains("disabled")))return void console.warn("Please select 1 document to print");const t=this.checkedDocUids[0],i=s.DDV.documentManager.getDocument(t);(null===(n=null==i?void 0:i.pages)||void 0===n?void 0:n.length)&&i.print()}async handleShare(){const e=[];for(let n=0;n<this.checkedDocUids.length;n++){const t=s.DDV.documentManager.getDocument(this.checkedDocUids[n]);if(t.pages.length){const n=await t.saveToPdf({mimeType:"application/octet-stream",saveAnnotation:"annotation",quality:100});e.push(new File([n],`${t.name}.pdf`,{type:"application/pdf"}))}}if(navigator.canShare&&navigator.canShare({files:e}))try{await navigator.share({files:e,title:"PDF Files"})}catch(e){"AbortError"!==e.name&&await A(this.config.container,"Failed to share files",E.ERROR)}else await A(this.config.container,"Your system doesn't support sharing PDF files",E.WARNING)}async handleDownload(){this.checkedDocUids.forEach((async e=>{var n;const t=s.DDV.documentManager.getDocument(e);(null===(n=null==t?void 0:t.pages)||void 0===n?void 0:n.length)&&await F.handleDownloadDoc(t,this.config.container)}))}async handleUploadDocuments(){var e,n;if(null===(n=null===(e=this.config)||void 0===e?void 0:e.exportConfig)||void 0===n?void 0:n.uploadToServer)try{const e=this.checkedDocUids.map((async e=>{var n,t,i,a,o,l;const c=s.DDV.documentManager.getDocument(e);if(null===(n=null==c?void 0:c.pages)||void 0===n?void 0:n.length){const e=await c.saveToPdf({mimeType:"application/pdf",saveAnnotation:"annotation",quality:100}),n=`${c.name}.pdf`,s=await(null===(i=null===(t=this.config)||void 0===t?void 0:t.exportConfig)||void 0===i?void 0:i.uploadToServer(n,e));if("success"===(null==s?void 0:s.status)){const t=this.config.getUploadedDocuments();t.push(s),this.config.updateUploadedDocuments(t);if(await(null===(o=null===(a=this.config.exportConfig)||void 0===a?void 0:a.onUploadSuccess)||void 0===o?void 0:o.call(a,n,"pdf",k.Library,e)))return void(null===(l=this.config)||void 0===l||l.onClose())}return s}await A(this.config.container,"Document contains no pages!",E.WARNING)})),n=await Promise.all(e);if((null==n?void 0:n.filter((e=>"success"===(null==e?void 0:e.status)))).length){this.handleSelectAllOrCancel(!0);await L({container:this.config.container,type:M.CONFIRM,variant:E.SUCCESS,title:"Upload Successful",confirmText:"View in Uploads",cancelText:"Continue"})&&this.handleViewUploadsHistory()}}catch(e){let n=(null==e?void 0:e.message)||e;console.error("Uploads failed:",n);await L({container:this.config.container,type:M.CONFIRM,variant:E.ERROR,title:"Uploads Failed",confirmText:"View Uploaded Files",cancelText:"Continue"})&&this.handleViewUploadsHistory()}else await A(this.config.container,"No upload function configured",E.WARNING)}async handleSelectedBack(){this.handleSelectAllOrCancel(!0)}}const O="\n  .mwc-view-header-actions {\n    position: absolute;\n    right: 1rem;\n    font-family: Verdana;\n    color: black;\n  }\n\n  .mwc-view-header-actions .mwc-library-header-btn {\n    border: none;\n    background: transparent;\n    display: flex;\n    align-content: center;\n    cursor: pointer;\n  }\n\n  .mwc-view-header-actions .mwc-library-header-btn.selectAll,\n  .mwc-view-header-actions .mwc-library-header-btn.cancel{\n    background: none;\n    border: none;\n    color: #FE8E14;\n    font-size: 14px;\n    cursor: pointer;\n    padding: 4px 8px;\n    align-content: end;\n  }\n\n  .mwc-default-empty-library {\n    display: flex;\n    flex-direction: column;\n    justify-content:center;\n    align-items: center;\n    gap: 1rem;\n  }\n\n  .mwc-default-empty-library svg {\n    width: 200px;\n    height: auto;\n  }\n\n  .mwc-default-empty-library .title {\n    margin-top: 2rem;\n    font-size: 24px;\n    color: black;\n  }\n\n  .mwc-default-empty-library .desc {\n    font-size: 16px;\n    color: black;\n  }\n",G={base:{type:s.DDV.Elements.Layout,className:"ddv-edit-viewer-header-mobile",children:[s.DDV.Elements.Pagination]},edit:{type:s.DDV.Elements.Layout,className:"ddv-edit-viewer-header-mobile",children:[s.DDV.Elements.Undo,s.DDV.Elements.Redo]}},Z={type:s.DDV.Elements.Layout,flexDirection:"column",className:"ddv-edit-viewer-mobile",children:[G.base,s.DDV.Elements.MainView,{type:s.DDV.Elements.Layout,className:"ddv-edit-viewer-footer-mobile",children:[{type:s.DDV.Elements.DeleteCurrent,events:{click:"showDocumentPageByDelete"}},s.DDV.Elements.Crop,s.DDV.Elements.Filter,{type:s.DDV.Elements.AnnotationSet,className:"mwc-annotation-set",pullDownBox:{className:"mwc-annotation-mode-bar"}}]}]};class z extends T{constructor(e){super(e),this.config=e,this.editViewer=null,this.toolbarBtn={back:null,delete:null,addPage:null,upload:null,share:null,edit:null,crop:null,rotate:null,filter:null,annotate:null,done:null},this.editToolbarContainer={},this.ddvAnnotationsToolbarLabel={Undo:"Undo",Redo:"Redo",SelectAnnotation:"Select",EraseAnnotation:"Eraser",RectAnnotation:"Rect",EllipseAnnotation:"Ellipse",PolygonAnnotation:"Polygon",PolylineAnnotation:"Polyline",LineAnnotation:"Line",InkAnnotation:"Ink",TextBoxAnnotation:"Textbox",TextTypewriterAnnotation:"Text",StampIconAnnotation:"Stamp",StampImageAnnotation:"Image",BringForward:"Up",BringToFront:"Top",SendBackward:"Down",SendToBack:"Bottom"},this.isCroppingMode=!1,this.isAnnotatingMode=!1,this.isFilterMode=!1}initialize(){D("mwc-page-view-style",q),super.initialize(),s.DDV.Elements.setDisplayTextConfig({...this.ddvAnnotationsToolbarLabel,...this.config.annotationToolbarLabelConfig}),this.editViewer=new s.DDV.EditViewer({container:this.MWCViewElements.contentContainer,uiConfig:Z,viewerConfig:{scrollToLatest:!0}}),this.editViewer.displayMode="single",this.MWCViewElements.contentContainer.style.padding="0px",this.bindPageViewEvents(),this.setVisible(!1)}bindPageViewEvents(){this.editViewer.on("showDocumentPageByDelete",(async()=>{this.editViewer.currentDocument.pages.length||this.handleBack(),await A(this.config.container,"Deleted",E.SUCCESS)})),this.bindAnnotationEvents(),this.bindToolModeEvents()}bindAnnotationEvents(){let e=!1;const n=document.querySelector(".mwc-annotation-set");!b()&&n&&n.addEventListener("click",(()=>{const n=document.querySelector(".ddv-annotation-mode-box");if(!e){e=!0;let t=!1;n.addEventListener("mousedown",(e=>{let n=e.target;e.target instanceof HTMLSpanElement&&(n=e.target.parentElement),n.classList.contains("ddv-button-focused")&&(t=!0)})),n.addEventListener("click",(()=>{t&&(this.editViewer.toolMode="pan",t=!1)}))}}))}bindToolModeEvents(){this.editViewer.on("toolModeChanged",(e=>{"crop"===e.oldToolMode&&(this.toolbarBtn.crop.classList.remove("selected"),this.enableAllEditButtons(),this.toggleDDVHeaderButtons(!0),this.isCroppingMode=!1)}))}createHeader(){super.createHeader(!1)}updateEmptyContentHTML(){const e=`\n      <div class="mwc-default-empty-page">\n        ${f.emptyLibrary}\n        <div class="title">No page to display!</div>\n      </div>\n    `;this.MWCViewElements.emptyContentContainer.innerHTML=e}createToolbars(){var e,n,t,i,a,o,l,s,c,d,r,h,m,u,p,v,w,g,b,y,C,D,V,x,k,P,M,E,S,A,L,H,T,B,N,R,I,U,_,F,W,$,O,G;super.createToolbars();const{toolbarButtonsConfig:Z,exportConfig:z}=this.config,q=new File([""],"test.pdf",{type:"application/pdf"}),j="share"in navigator&&navigator.canShare({files:[q]}),X=()=>{j?this.handleShare():this.handleDownload()},Y=!!(null==z?void 0:z.uploadToServer);[{id:"mwc-page-back",icon:(null===(e=null==Z?void 0:Z.back)||void 0===e?void 0:e.icon)||f.back,label:(null===(n=null==Z?void 0:Z.back)||void 0===n?void 0:n.label)||"Back",isHidden:null===(t=null==Z?void 0:Z.back)||void 0===t?void 0:t.isHidden,className:`${(null===(i=null==Z?void 0:Z.back)||void 0===i?void 0:i.className)||""}`,onClick:()=>this.handleBack()},{id:"mwc-page-delete",icon:(null===(a=null==Z?void 0:Z.delete)||void 0===a?void 0:a.icon)||f.delete,label:(null===(o=null==Z?void 0:Z.delete)||void 0===o?void 0:o.label)||"Delete",isHidden:null===(l=null==Z?void 0:Z.delete)||void 0===l?void 0:l.isHidden,className:`${(null===(s=null==Z?void 0:Z.delete)||void 0===s?void 0:s.className)||""}`,onClick:()=>this.handleDeletePage()},{id:"mwc-page-addPage",icon:(null===(c=null==Z?void 0:Z.addPage)||void 0===c?void 0:c.icon)||f.captureAnother,label:(null===(d=null==Z?void 0:Z.addPage)||void 0===d?void 0:d.label)||"Add Page",isHidden:null===(r=null==Z?void 0:Z.addPage)||void 0===r?void 0:r.isHidden,className:`${(null===(h=null==Z?void 0:Z.addPage)||void 0===h?void 0:h.className)||""}`,onClick:()=>this.handleAddPage()},{id:"mwc-page-share",icon:(null===(m=null==Z?void 0:Z.share)||void 0===m?void 0:m.icon)||(j?f.sharePNG:f.downloadPNG),label:(null===(u=null==Z?void 0:Z.share)||void 0===u?void 0:u.label)||(j?"Share":"Download"),isHidden:null===(p=null==Z?void 0:Z.share)||void 0===p?void 0:p.isHidden,className:`${(null===(v=null==Z?void 0:Z.share)||void 0===v?void 0:v.className)||""}`,onClick:()=>X()},{id:"mwc-page-upload",icon:(null===(w=null==Z?void 0:Z.upload)||void 0===w?void 0:w.icon)||f.uploadPNG,label:(null===(g=null==Z?void 0:Z.upload)||void 0===g?void 0:g.label)||"Upload",isHidden:(null===(b=null==Z?void 0:Z.upload)||void 0===b?void 0:b.isHidden)||!Y,className:`${(null===(y=null==Z?void 0:Z.upload)||void 0===y?void 0:y.className)||""}`,onClick:()=>this.handleUpload()},{id:"mwc-page-edit",icon:(null===(C=null==Z?void 0:Z.edit)||void 0===C?void 0:C.icon)||f.edit,label:(null===(D=null==Z?void 0:Z.edit)||void 0===D?void 0:D.label)||"Edit",isHidden:null===(V=null==Z?void 0:Z.edit)||void 0===V?void 0:V.isHidden,className:`${(null===(x=null==Z?void 0:Z.edit)||void 0===x?void 0:x.className)||""}`,onClick:()=>this.handleEditMode()}].forEach((e=>{const n=this.createToolbarButton(e);this.toolbarBtn[e.id.split("-").pop()]=n,this.MWCViewElements.toolbarContainer.appendChild(n)}));[{id:"mwc-page-crop",icon:(null===(k=null==Z?void 0:Z.crop)||void 0===k?void 0:k.icon)||f.crop,label:(null===(P=null==Z?void 0:Z.crop)||void 0===P?void 0:P.label)||"Crop",isHidden:null===(M=null==Z?void 0:Z.crop)||void 0===M?void 0:M.isHidden,className:`${(null===(E=null==Z?void 0:Z.crop)||void 0===E?void 0:E.className)||""}`,onClick:()=>this.handleCrop()},{id:"mwc-page-rotate",icon:(null===(S=null==Z?void 0:Z.rotate)||void 0===S?void 0:S.icon)||f.rotate,label:(null===(A=null==Z?void 0:Z.rotate)||void 0===A?void 0:A.label)||"Rotate",isHidden:null===(L=null==Z?void 0:Z.rotate)||void 0===L?void 0:L.isHidden,className:`${(null===(H=null==Z?void 0:Z.rotate)||void 0===H?void 0:H.className)||""}`,onClick:()=>this.handleRotate()},{id:"mwc-page-filter",icon:(null===(T=null==Z?void 0:Z.filter)||void 0===T?void 0:T.icon)||f.filter,label:(null===(B=null==Z?void 0:Z.filter)||void 0===B?void 0:B.label)||"Filter",isHidden:null===(N=null==Z?void 0:Z.filter)||void 0===N?void 0:N.isHidden,className:`${(null===(R=null==Z?void 0:Z.filter)||void 0===R?void 0:R.className)||""}`,onClick:()=>this.handleFilter()},{id:"mwc-page-annotate",icon:(null===(I=null==Z?void 0:Z.annotate)||void 0===I?void 0:I.icon)||f.annotate,label:(null===(U=null==Z?void 0:Z.annotate)||void 0===U?void 0:U.label)||"Annotate",isHidden:null===(_=null==Z?void 0:Z.annotate)||void 0===_?void 0:_.isHidden,className:`${(null===(F=null==Z?void 0:Z.annotate)||void 0===F?void 0:F.className)||""}`,onClick:()=>this.handleAnnotate()},{id:"mwc-page-done",icon:(null===(W=null==Z?void 0:Z.done)||void 0===W?void 0:W.icon)||f.done,label:(null===($=null==Z?void 0:Z.done)||void 0===$?void 0:$.label)||"Done",isHidden:null===(O=null==Z?void 0:Z.done)||void 0===O?void 0:O.isHidden,className:`done ${(null===(G=null==Z?void 0:Z.done)||void 0===G?void 0:G.className)||""}`,onClick:()=>this.handleDoneBtn()}].forEach((e=>{const n=this.createToolbarButton(e);this.toolbarBtn[e.id.split("-").pop()]=n,this.MWCViewElements.selectedToolbarContainer.appendChild(n)}))}setVisible(e){var n,t;super.setVisible(e),e?(this.showContent(!0),null===(n=this.editViewer)||void 0===n||n.show()):null===(t=this.editViewer)||void 0===t||t.hide()}openPage(e,n){this.editViewer.openDocument(e),this.editViewer.goToPage(n),this.editViewer.show()}handleBack(){var e,n;null===(n=(e=this.config).onDocumentClick)||void 0===n||n.call(e)}async handleDeletePage(){await L({container:this.config.container,type:M.CONFIRM,variant:E.WARNING,title:"Delete Page",message:"Are you sure you want to delete this page?",confirmText:"Delete",cancelText:"Cancel",showCloseBtn:!0})&&this.config.container.querySelector(".ddv-delete-current").click()}handleAddPage(){const e=this.toolbarBtn.addPage;let n=e.querySelector(".mwc-add-page-menu");if(n)n.classList.toggle("show");else{D("mwc-add-page-dropdown-style",j),n=document.createElement("div"),n.className="mwc-add-page-menu",n.innerHTML=`\n        <button class="mwc-add-page-option capture">\n          ${f.cameraCapture}\n          <span>Capture</span>\n        </button>\n        <button class="mwc-add-page-option import">\n          ${f.galleryImport}\n          <span>Import</span>\n        </button>\n      `;n.querySelector(".capture").addEventListener("click",(async e=>{var t,i;n.classList.contains("show")&&n.classList.remove("show"),await(null===(i=(t=this.config).onCameraCapture)||void 0===i?void 0:i.call(t)),e.stopPropagation()}));n.querySelector(".import").addEventListener("click",(async e=>{var t,i;n.classList.contains("show")&&n.classList.remove("show"),await(null===(i=(t=this.config).onGalleryImport)||void 0===i?void 0:i.call(t)),e.stopPropagation()})),document.addEventListener("click",(t=>{!e.contains(t.target)&&n.classList.contains("show")&&n.classList.remove("show")})),e.querySelector(".icon").prepend(n),n.classList.toggle("show")}}async handleShare(){try{const e=this.editViewer.currentDocument,n=this.editViewer.getCurrentPageIndex(),t=await e.saveToPng(n,{saveAnnotation:!0}),i=[new File([t],`${e.name}-${Date.now()}.png`,{type:t.type})];if(navigator.canShare&&navigator.canShare({files:i}))try{await navigator.share({files:i,title:"Image Files"})}catch(e){"AbortError"!==e.name&&await A(this.config.container,"Failed to share files",E.ERROR)}else await A(this.config.container,"Failed to share",E.WARNING)}catch(e){await A(this.config.container,"Error processing files",E.ERROR)}}async handleDownload(){try{const e=this.editViewer.currentDocument,n=this.editViewer.getCurrentPageIndex(),t=await e.saveToPng(n,{saveAnnotation:!0}),i=URL.createObjectURL(t),a=document.createElement("a");a.href=i,a.download=`${e.name}.png`,a.click(),a.remove(),URL.revokeObjectURL(i),await A(this.config.container,"Downloaded",E.SUCCESS)}catch(e){const n=(null==e?void 0:e.message)||e;console.warn("Download failed:",n),await A(this.config.container,"Failed to download page",E.ERROR)}}async handleUpload(){var e,n,t,i,a,o,l,s,c;if(null===(n=null===(e=this.config)||void 0===e?void 0:e.exportConfig)||void 0===n?void 0:n.uploadToServer)try{const e=this.editViewer.currentDocument,n=this.editViewer.getCurrentPageIndex(),d=await e.saveToPng(n,{saveAnnotation:!0}),r=`${e.name}-${n}.png`,h=await(null===(i=null===(t=this.config)||void 0===t?void 0:t.exportConfig)||void 0===i?void 0:i.uploadToServer(r,d));if("success"===(null==h?void 0:h.status)){if(await(null===(o=null===(a=this.config.exportConfig)||void 0===a?void 0:a.onUploadSuccess)||void 0===o?void 0:o.call(a,r,"png",k.Page,d)))return void(null===(l=this.config)||void 0===l||l.onClose());const e=this.config.getUploadedDocuments();e.push(h),this.config.updateUploadedDocuments(e);await L({container:this.config.container,type:M.CONFIRM,variant:E.SUCCESS,title:"Upload Successful",confirmText:"View in Uploads",cancelText:"Continue"})&&(null===(c=(s=this.config).onViewUploadsHistory)||void 0===c||c.call(s))}}catch(e){const n=(null==e?void 0:e.message)||e;console.error("Upload failed:",n),await A(this.config.container,"Failed to upload page",E.ERROR)}else await A(this.config.container,"No upload function configured",E.WARNING)}async handleEditMode(){try{if(!this.updateEditViewTopbar("edit"))throw new Error("Failed to update edit viewer");this.toggleSelectionMode(!0)}catch(e){await A(this.config.container,"Failed to enter edit mode",E.ERROR),console.error(e)}}updateEditViewTopbar(e){const n=this.editViewer.getUiConfig();return n.children[0]=G[e],this.editViewer.updateUiConfig(n)}toggleDDVHeaderButtons(e){const n=this.config.container.querySelector(".ddv-edit-viewer-header-mobile"),t=e?"remove":"add";n.childNodes.forEach((e=>e.classList[t]("ddv-disable-button")))}disableOtherEditButtons(e){this.config.container.querySelectorAll(".mwc-view-controls-container")[1].childNodes.forEach((n=>{n!==e&&n!==this.toolbarBtn.done&&n.classList.add("ddv-disable-button")}))}enableAllEditButtons(){this.config.container.querySelectorAll(".mwc-view-controls-container")[1].childNodes.forEach((e=>{e.classList.remove("ddv-disable-button")}))}handleCrop(){this.config.container.querySelector(".ddv-button.ddv-crop").click(),this.disableOtherEditButtons(this.toolbarBtn.crop),this.toolbarBtn.crop.classList.add("selected"),this.toggleDDVHeaderButtons(!1)}handleRotate(){this.editViewer.rotate(-90)}handleFilter(){this.config.container.querySelector(".ddv-button.ddv-filter").click(),this.isFilterMode?(this.isFilterMode=!1,this.toolbarBtn.filter.classList.remove("selected"),this.enableAllEditButtons()):(this.isFilterMode=!0,this.isAnnotatingMode=!1,this.disableOtherEditButtons(this.toolbarBtn.filter),this.toolbarBtn.filter.classList.add("selected"),this.toolbarBtn.annotate.classList.remove("selected"))}handleAnnotate(){this.config.container.querySelector(".mwc-annotation-set").click(),this.isAnnotatingMode?(this.isAnnotatingMode=!1,this.toolbarBtn.annotate.classList.remove("selected"),this.enableAllEditButtons(),this.editViewer.toolMode="pan"):(this.isAnnotatingMode=!0,this.isFilterMode=!1,this.disableOtherEditButtons(this.toolbarBtn.annotate),this.toolbarBtn.annotate.classList.add("selected"),this.toolbarBtn.filter.classList.remove("selected"))}async handleDoneBtn(){try{const e=await L({container:this.config.container,type:M.CONFIRM,variant:E.WARNING,title:"Exit Edit Mode",message:"You might have unsaved changes. Do you want to save before exiting?",confirmText:"Save & Exit",cancelText:"Discard",showCloseBtn:!0});if(null===e)return;if(e)this.editViewer.saveOperations();else{for(;this.editViewer.undo(););this.editViewer.saveOperations()}this.isAnnotatingMode=!1,this.isFilterMode=!1,this.toolbarBtn.annotate.classList.remove("selected"),this.toolbarBtn.filter.classList.remove("selected"),"pan"!==this.editViewer.toolMode&&(this.editViewer.toolMode="pan");if(!this.updateEditViewTopbar("base"))throw new Error("Failed to update edit viewer");this.toggleSelectionMode(!1),this.enableAllEditButtons()}catch(e){await A(this.config.container,"Failed to exit edit mode",E.ERROR),console.error(e)}}dispose(){var e;null===(e=this.editViewer)||void 0===e||e.destroy(),this.editViewer=null,this.config.container&&(this.config.container.style.display="none")}}const q="\n.done .label {\n  color: #fe8e14\n}\n\n.ddv-edit-viewer-footer-mobile{\n  height: 0;\n  display: none;\n}\n\n.ddv-annotation-mode-box,\n.ddv-crop-box,\n.ddv-filter-list {\n  top: unset !important;\n  bottom: 0;\n}\n\n.ddv-disable-button {\n  opacity: 0.3;\n  pointer-events: none;\n}\n\n.mwc-annotation-mode-bar {\n  overflow-y: hidden;\n  height: 70px;\n\n  scrollbar-width: thin;\n  scrollbar-color: rgb(193,193,193) rgb(241,241,241); \n}\n.mwc-annotation-mode-bar > .ddv-button {\n  height: 50px;\n  width: 50px;\n}\n\n.mwc-annotation-mode-bar::-webkit-scrollbar {\n  width: 5px;\n  height: 5px;\n  border-radius: 0px;\n}\n\n.mwc-annotation-mode-bar::-webkit-scrollbar-thumb { \n  border-radius: 0px;\n  background-color: rgb(193,193,193);\n}  \n\n.mwc-annotation-mode-bar::-webkit-scrollbar-track {\n  border-radius: 0px;\n  background-color: rgb(241,241,241);\n}\n\n.ddv-undo-page, .ddv-redo-page {\n  flex-direction: column;\n}\n",j="\n  .mwc-view-controls-btn {\n    position: relative; /* Add this to make the absolute positioning work relative to button */\n  }\n\n  .mwc-add-page-menu {\n    position: absolute;\n    bottom: 6rem;\n    transform: translate(-50%);\n    left: 50%;\n    right: 50%;\n    width: max-content;\n    background-color: #323234;\n    border-radius: 0.5rem;\n    overflow: visible;\n    display: none;\n    margin-bottom: 0.5px; /* Add some spacing between menu and button */\n    box-shadow: 0 -2px 10px rgba(0, 0, 0, 0.2); /* Add shadow for better visibility */\n  }\n\n  .mwc-add-page-menu::after {\n    content: '';\n    position: absolute;\n    bottom: -8px; /* Triangle */\n    left: 50%;\n    right: 50%;\n    transform: translateX(-50%);\n    width: 0;\n    height: 0;\n    border-left: 8px solid transparent;\n    border-right: 8px solid transparent;\n    border-top: 8px solid #323234; /* Same color as menu background */\n  }\n\n  \n  .mwc-add-page-menu.show {\n    display: block;\n  }\n  \n  .mwc-add-page-option {\n    display: flex;\n    align-items: center;\n    gap: 1rem;\n    padding: 1rem;\n    color: white;\n    background: none;\n    border: none;\n    cursor: pointer;\n    font-family: Verdana;\n    font-size: 14px;\n    width: 100%;\n    box-sizing: border-box;\n  }\n\n  .mwc-add-page-option svg {\n    width: 24px;\n    height: 24px;\n  }\n\n  .mwc-add-page-option span {\n    cursor: pointer;\n  }\n  \n  .mwc-add-page-option:hover {\n    background-color: rgba(255, 255, 255, 0.1);\n  }\n\n  .mwc-add-page-option:not(:last-child) {\n    border-bottom: 1px solid rgba(255, 255, 255, 0.1);\n  }\n";class X{constructor(e){this.config=e,this.createUI(),this.bindEvents()}createUI(){D("mwc-history-item-style",Y),this.dom=document.createElement("div"),this.dom.className="mwc-library-view-history-item",this.dom.innerHTML=`\n      <div class="mwc-library-view-history-name">${this.config.doc.fileName}</div>\n      <div class="mwc-library-view-history-time">${function(e){if(!e)return"";const n=(Number(e)-621355968e9)/1e4,t=6e4*new Date(n).getTimezoneOffset();return new Date(n+t).toLocaleString("en-US",{year:"numeric",month:"short",day:"numeric",hour:"2-digit",minute:"2-digit"})}(this.config.doc.uploadTime)||""}</div>\n      <div class="mwc-library-view-history-actions">\n        <button class="mwc-library-view-history-action-btn delete">Delete</button>\n        <span class="mwc-library-view-history-separator">|</span>\n        <button class="mwc-library-view-history-action-btn download">Download</button>\n      </div>\n    `}bindEvents(){const e=this.dom.querySelector(".delete"),n=this.dom.querySelector(".download");null==e||e.addEventListener("click",(()=>this.handleDelete())),null==n||n.addEventListener("click",(()=>this.handleDownload()))}async handleDelete(){var e,n;await L({container:this.config.container,type:M.CONFIRM,variant:E.WARNING,title:"Delete Document",message:"Are you sure you want to delete this document from the server?",confirmText:"Delete",cancelText:"Cancel",showCloseBtn:!0})&&(await(null===(n=null===(e=this.config)||void 0===e?void 0:e.onDeleteDocument)||void 0===n?void 0:n.call(e,this.config.doc)),this.dispose(),await A(this.config.container,"Deleted",E.SUCCESS))}async handleDownload(){var e,n;await(null===(n=null===(e=this.config)||void 0===e?void 0:e.onDownloadDocument)||void 0===n?void 0:n.call(e,this.config.doc))}getDom(){return this.dom}dispose(){this.dom.remove()}}const Y="\n.mwc-library-view-history-item {\n  display: flex;\n  flex-direction: column;\n  font-family: Verdana;\n  padding: 16px;\n  border-bottom: 1px solid #e6e6e6;\n}\n\n.mwc-library-view-history-item:last-child {\n  border-bottom: none;\n}\n\n.mwc-library-view-history-name {\n  font-size: 16px;\n}\n\n.mwc-library-view-history-time {\n  color: #888888;\n  font-size: 16px;\n}\n\n.mwc-library-view-history-actions {\n  display: flex;\n  align-items: center;\n  gap: 8px;\n}\n\n.mwc-library-view-history-action-btn {\n  color: #FE8E14;\n  cursor: pointer;\n  background: none;\n  border: none;\n  font-family: Verdana;\n  padding: 0;\n  font-size: 16px;\n}\n\n.mwc-library-view-history-action-btn:hover {\n  text-decoration: underline;\n}\n\n.mwc-library-view-history-separator {\n  color: #E0E0E0;\n}\n";class J extends T{constructor(e){super(e),this.config=e,this.currentCaller=k.Library,this.toolbarBtn={back:null}}initialize(){D("mwc-history-view-style",K),super.initialize(),this.updateEmptyContentHTML(),this.setVisible(!1)}setVisible(e,n){var t;super.setVisible(e),e&&(this.currentCaller=n.caller,this.showContent(!!(null===(t=this.config.getUploadedDocuments())||void 0===t?void 0:t.length)),this.loadUploadedFiles())}createHeader(){super.createHeader(),this.MWCViewElements.headerContainer.innerHTML='\n      <div class="mwc-view-header-title">Upload History</div>\n    '}updateEmptyContentHTML(){const e=`\n    <div class="mwc-default-empty-history">\n      ${f.emptyLibrary}\n      <div class="title">\n        No uploaded files found!\n      </div>\n    </div>\n    `;super.setEmptyContent(this.config.emptyContentConfig||e)}createToolbars(){var e,n,t,i;super.createToolbars();const{toolbarButtonsConfig:a}=this.config;[null,null,null,{id:"mwc-history-back",icon:(null===(e=null==a?void 0:a.back)||void 0===e?void 0:e.icon)||f.back,label:(null===(n=null==a?void 0:a.back)||void 0===n?void 0:n.label)||"Back",className:(null===(t=null==a?void 0:a.back)||void 0===t?void 0:t.className)||"",isHidden:null===(i=null==a?void 0:a.back)||void 0===i?void 0:i.isHidden,onClick:()=>{var e,n;return null===(n=(e=this.config).onBack)||void 0===n?void 0:n.call(e,this.currentCaller)}}].forEach((e=>{const n=this.createToolbarButton(e);e&&(this.toolbarBtn[e.id.split("-").pop()]=n),this.MWCViewElements.toolbarContainer.appendChild(n)}))}loadUploadedFiles(){var e;this.MWCViewElements.contentContainer.textContent="",null===(e=this.config.getUploadedDocuments())||void 0===e||e.forEach((e=>{const n=new X({container:this.config.container,doc:e,onDeleteDocument:()=>this.handleHistoryDelete(e),onDownloadDocument:()=>this.handleHistoryDownload(e)});this.MWCViewElements.contentContainer.append(n.getDom())}))}handleHistoryDelete(e){var n,t;e&&(null===(t=null===(n=this.config)||void 0===n?void 0:n.exportConfig)||void 0===t||t.deleteFromServer(e).then((async()=>{var n,t;const i=null===(n=this.config.getUploadedDocuments())||void 0===n?void 0:n.filter((n=>n.uploadTime!==e.uploadTime));this.config.updateUploadedDocuments(i),this.showContent(!!(null===(t=this.config.getUploadedDocuments())||void 0===t?void 0:t.length)),await A(this.config.container,"Deleted",E.SUCCESS)})).catch((async()=>{await A(this.config.container,"Failed",E.ERROR)})))}handleHistoryDownload(e){var n,t;null===(t=null===(n=this.config)||void 0===n?void 0:n.exportConfig)||void 0===t||t.downloadFromServer(e).then((async()=>{await A(this.config.container,"Downloaded",E.SUCCESS)})).catch((async()=>{await A(this.config.container,"Failed",E.ERROR)}))}dispose(){this.config.container&&(this.config.container.style.display="none",this.MWCViewElements.contentContainer.textContent="")}}const K="\n  .mwc-default-empty-history {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    gap: 1rem;\n  }\n\n  .mwc-default-empty-history svg {\n    width: 200px;\n    height: auto;\n  }\n\n  .mwc-default-empty-history .title {\n    margin-top: 2rem;\n    font-size: 24px;\n        color: black;\n  }\n\n  .mwc-default-empty-history .desc {\n    font-size: 16px;\n        color: black;\n  }\n",Q="mwc-ddv-css",ee="https://cdn.jsdelivr.net/npm/dynamsoft-document-viewer@2.1.0/dist";class ne{showMWCLoadingOverlay(e){const n=y(this.config.container);this.loadingScreen=function(e,n={}){const{message:t,spinnerSize:i=32}=n,a=document.createElement("div");a.className="mwc-loading-screen";const o=document.createElement("div");o.className="mwc-loading";const l=document.createElement("div");l.className="mwc-loading-content";const s=`\n    <svg \n      xmlns="http://www.w3.org/2000/svg" \n      viewBox="0 0 24 24" \n      fill="none" \n      stroke="white" \n      stroke-linecap="round" \n      stroke-linejoin="round" \n      width="${i}" \n      height="${i}" \n      stroke-width="0.75"\n    > \n      <path d="M12 3a9 9 0 1 0 9 9"></path> \n    </svg>\n  `;if(l.innerHTML=s,t){const e=document.createElement("div");e.className="mwc-loading-message",e.textContent=t,l.appendChild(e)}return o.appendChild(l),a.appendChild(o),e.appendChild(a),{element:a,updateMessage:e=>{let n=o.querySelector(".dds-loading-message");null!==e?n?n.textContent=e:(n=document.createElement("div"),n.className="mwc-loading-message",n.textContent=e,l.appendChild(n)):null==n||n.remove()},hide:()=>{a&&a.parentNode&&(a.classList.add("fade-out"),setTimeout((()=>{var e;null===(e=a.parentNode)||void 0===e||e.removeChild(a)}),200))}}}(n,{message:e})}hideMWCLoadingOverlay(){this.loadingScreen&&(this.loadingScreen.hide(),this.loadingScreen=null)}constructor(e){this.config=e,this.currentView=null,this.uploadedFiles=[],this.isInitialized=!1,this.isUsingDefaultContainer=!1,this.hasLaunched=!1,this.loadingScreen=null,this.updateUploadedDocuments=e=>{this.uploadedFiles=e}}async initialize(){var e;if(!this.isInitialized)try{this.setupMWCViews(),D("mwc-loading-screen-style",'\n  .mwc-loading-screen {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    background-color: #323234;\n    z-index: 998;\n    opacity: 1;\n    transition: opacity 0.2s ease-out;\n  }\n\n  .mwc-loading-screen.fade-out {\n    opacity: 0;\n  }\n\n  .mwc-loading {\n    position: absolute;\n    left: 50%;\n    top: 50%;\n    color: white;\n    z-index: 999;\n    transform: translate(-50%, -50%);\n  }\n\n  .mwc-loading-content {\n    display: flex;\n    flex-direction: column;\n    align-items: center;\n    gap: 16px;\n  }\n\n  .mwc-loading svg {\n    animation: spin 1s linear infinite;\n  }\n\n  .mwc-loading-message {\n    color: white;\n    font-family: "Verdana";\n    font-size: 14px;\n    text-align: center;\n    max-width: 200px;\n    line-height: 1.4;\n    opacity: 0.9;\n  }\n\n  @keyframes spin {\n    from {\n      transform: rotate(0deg);\n    }\n    to {\n      transform: rotate(360deg);\n    }\n  }\n'),this.showMWCLoadingOverlay("Initializing"),this.scanner&&await this.scanner.initialize(),await this.loadDDVcss(),s.DDV.Core.license=this.config.license,s.DDV.Core.engineResourcePath=`${(null===(e=this.config)||void 0===e?void 0:e.ddvResourcePath)||ee}/engine`,await this.initializeDDV(),this.initializeMWCViews(),this.isInitialized=!0}catch(e){this.isInitialized=!1;const n=(null==e?void 0:e.message)||e;throw console.error(n),new Error(n)}finally{this.hideMWCLoadingOverlay()}}async launch(e,n){try{if(this.hasLaunched)throw new Error("Failed to launch this MobileWebCapture instance as it is already running");if(this.hasLaunched=!0,this.isInitialized||await this.initialize(),e)return void(e instanceof File?n===k.Library&&this.config.showLibraryView?await this.createDocumentFromFile(e,k.Library):await this.createDocumentFromFile(e,k.Document):"string"==typeof e&&(n===k.Library&&this.config.showLibraryView?await this.createDocumentFromName(e,k.Library):await this.createDocumentFromName(e,k.Document)));e||(n===k.Library?await this.handleDefaultLaunch(k.Library):n===k.Document?await this.createDocumentFromName(`Doc-${Date.now()}`,k.Document):this.config.showLibraryView?await this.handleDefaultLaunch(k.Library):await this.createDocumentFromName(`Doc-${Date.now()}`,k.Document))}catch(e){const n=(null==e?void 0:e.message)||e;throw this.dispose(),new Error(`Launch MWC Failed: ${n}`)}}async createDocumentFromFile(e,n){const t=C(null==e?void 0:e.name),i=[{convertMode:"cm/auto",fileData:new Blob([e],{type:e.type}),renderOptions:{renderAnnotations:"loadAnnotations"}}];if(this.config.showLibraryView){const e=await this.mwcViews.library.instance.createAndLoadDocument(t,i);n===k.Document?this.handleDocumentClick(e.uid):this.switchView(n||k.Library)}else{const e=s.DDV.documentManager.createDocument({name:t});await e.loadSource(i),this.handleDocumentClick(e.uid)}}async createDocumentFromName(e,n){const t=C(e);if(this.config.showLibraryView){const e=await this.mwcViews.library.instance.createAndLoadDocument(t);n===k.Document?this.handleDocumentClick(e.uid):this.switchView(n||k.Library)}else{const e=s.DDV.documentManager.createDocument({name:t});this.handleDocumentClick(e.uid)}}async handleDefaultLaunch(e){if(this.config.showLibraryView)this.switchView(e||k.Library);else try{const e=s.DDV.documentManager.createDocument({name:`Doc-${Date.now()}`});this.mwcViews[k.Document].instance.browseViewer.openDocument(e.uid),this.switchView(k.Document),await A(this.mwcViews[k.Document].config.container,"Document Created",E.SUCCESS)}catch(e){throw new Error(`Failed to create empty document: ${e.message}`)}}setupMWCViews(){var e,n,t,i,a,o,l,s,d,r,h,m,u,p,v,w,g,f,b,C,D;const{license:V,exportConfig:x,showLibraryView:M}=this.config;this.config.license=this.checkForTemporaryLicense(V),this.config.container?(this.config.container=y(this.config.container),this.config.container.style.position="absolute"!==(null===(n=null===(e=this.config.container)||void 0===e?void 0:e.style)||void 0===n?void 0:n.position)&&"fixed"!==(null===(i=null===(t=this.config.container)||void 0===t?void 0:t.style)||void 0===i?void 0:i.position)?"relative":null===(o=null===(a=this.config.container)||void 0===a?void 0:a.style)||void 0===o?void 0:o.position):this.config.container=this.createDefaultMWCContainer();const E=this.createMWCViewContainers(this.config.container);this.config.libraryViewConfig={...this.config.libraryViewConfig,container:E[P.Library]},this.config.documentViewConfig={...this.config.documentViewConfig,container:E[P.Document]},this.config.pageViewConfig={...this.config.pageViewConfig,container:E[P.Page]},this.config.transferViewConfig={...this.config.transferViewConfig,container:E[P.Transfer]},this.config.historyViewConfig={...this.config.historyViewConfig,container:E[P.History]},this.config.scanner?this.scanner=this.config.scanner||null:(this.config.documentScannerConfig={...this.config.documentScannerConfig,scannerViewConfig:{...null===(l=this.config.documentScannerConfig)||void 0===l?void 0:l.scannerViewConfig,container:E[P.Scanner]},...!1!==(null===(s=this.config.documentScannerConfig)||void 0===s?void 0:s.showResultView)&&{resultViewConfig:{...null===(d=this.config.documentScannerConfig)||void 0===d?void 0:d.resultViewConfig,container:E[P.ScanResult]}},...!1!==(null===(r=this.config.documentScannerConfig)||void 0===r?void 0:r.showCorrectionView)&&{correctionViewConfig:{...null===(h=this.config.documentScannerConfig)||void 0===h?void 0:h.correctionViewConfig,container:E[P.Correction]}},correctionViewConfig:{...null===(m=this.config.documentScannerConfig)||void 0===m?void 0:m.scannerViewConfig,container:E[P.Correction]}},this.scanner=new c.DocumentScanner({license:this.config.license,...this.config.documentScannerConfig,scannerViewConfig:null===(u=this.config.documentScannerConfig)||void 0===u?void 0:u.scannerViewConfig,resultViewConfig:!1===(null===(p=this.config.documentScannerConfig)||void 0===p?void 0:p.showResultView)||null===(v=this.config.documentScannerConfig)||void 0===v?void 0:v.resultViewConfig,correctionViewConfig:!1===(null===(w=this.config.documentScannerConfig)||void 0===w?void 0:w.showCorrectionView)||null===(g=this.config.documentScannerConfig)||void 0===g?void 0:g.correctionViewConfig,showResultView:null===(b=null===(f=this.config.documentScannerConfig)||void 0===f?void 0:f.showResultView)||void 0===b||b,showCorrectionView:null===(D=null===(C=this.config.documentScannerConfig)||void 0===C?void 0:C.showCorrectionView)||void 0===D||D})),this.mwcViews={[k.Library]:{config:{...this.config.libraryViewConfig,container:this.config.libraryViewConfig.container,onCameraCapture:()=>this.handleCameraCapture(k.Library),onGalleryImport:()=>this.handleGalleryImport(k.Library),onDocumentClick:e=>this.handleDocumentClick(e),onViewUploadsHistory:()=>this.switchView(k.History,{caller:k.Library}),onClose:()=>this.dispose(),exportConfig:x,getUploadedDocuments:()=>this.getUploadedDocuments(),updateUploadedDocuments:e=>this.updateUploadedDocuments(e)}},[k.Document]:{config:{...this.config.documentViewConfig,container:this.config.documentViewConfig.container,onBackToLibrary:()=>this.switchView(k.Library),onCameraCapture:()=>this.handleCameraCapture(k.Document),onGalleryImport:()=>this.handleGalleryImport(k.Document),onPageClick:(e,n)=>this.handlePageClick(e,n),onViewUploadsHistory:()=>this.switchView(k.History,{caller:k.Document}),onClose:()=>this.dispose(),exportConfig:x,getUploadedDocuments:()=>this.getUploadedDocuments(),updateUploadedDocuments:e=>this.updateUploadedDocuments(e),onTransferPages:(e,n,t)=>this.handleTransferPage(e,n,t),showLibraryView:M}},[k.Page]:{config:{...this.config.pageViewConfig,container:this.config.pageViewConfig.container,onDocumentClick:()=>this.switchView(k.Document),onCameraCapture:()=>this.handleCameraCapture(k.Page),onGalleryImport:()=>this.handleGalleryImport(k.Page),onViewUploadsHistory:()=>this.switchView(k.History,{caller:k.Page}),onClose:()=>this.dispose(),exportConfig:x,getUploadedDocuments:()=>this.getUploadedDocuments(),updateUploadedDocuments:e=>this.updateUploadedDocuments(e),showLibraryView:M}},[k.Transfer]:{config:{...this.config.transferViewConfig,container:this.config.transferViewConfig.container,onConfirmTransfer:e=>this.handleTransferPageConfirm(e),onCancelTransfer:()=>this.handleTransferPageCancel()}},[k.History]:{config:{...this.config.historyViewConfig,container:this.config.historyViewConfig.container,exportConfig:x,getUploadedDocuments:()=>this.getUploadedDocuments(),updateUploadedDocuments:e=>this.updateUploadedDocuments(e),onBack:e=>this.handleHistoryBack(e)}},[k.Scanner]:{config:{}}}}getDDSViewsToCreate(){var e,n,t,i;const a=null===(n=null===(e=this.config.documentScannerConfig)||void 0===e?void 0:e.showResultView)||void 0===n||n,o=null===(i=null===(t=this.config.documentScannerConfig)||void 0===t?void 0:t.showCorrectionView)||void 0===i||i,l=[P.Scanner];return a&&l.push(P.ScanResult),o&&l.push(P.Correction),l}createMWCViewContainers(e){const n=this.getDDSViewsToCreate(),t=Object.values(k),i=(e,n)=>{const t=document.createElement("div");return t.className=`mwc-view-container mwc-${e}-view-container`,Object.assign(t.style,n),t};return{...n.reduce(((n,t)=>{const a=i(t,{position:"absolute",height:"100%",width:"100%",top:"0",left:"0",zIndex:"1000",display:"none"});return e.append(a),n[t]=a,n}),{}),...t.reduce(((n,t)=>{const a=i(t,{position:"relative",height:"100%",width:"100%",display:"none"});return e.append(a),n[t]=a,n}),{})}}createDefaultMWCContainer(){const e=document.createElement("div");return e.className="mwc-main-container",Object.assign(e.style,{height:"100dvh",width:"100%",position:"absolute",left:0,top:0,display:"none"}),document.body.append(e),this.isUsingDefaultContainer=!0,e}checkForTemporaryLicense(e){return!(null==e?void 0:e.length)||(null==e?void 0:e.startsWith("A"))||(null==e?void 0:e.startsWith("L"))||(null==e?void 0:e.startsWith("P"))||(null==e?void 0:e.startsWith("Y"))?"DLS2eyJvcmdhbml6YXRpb25JRCI6IjIwMDAwMSJ9":e}loadDDVcss(){var e;if(document.getElementById(Q))return;const n=(null===(e=this.config)||void 0===e?void 0:e.ddvResourcePath)||ee;return new Promise(((e,t)=>{const i=document.createElement("link");i.rel="stylesheet",i.href=`${n}/ddv.css`,i.id=Q,i.onload=()=>e(),i.onerror=()=>t(new Error(`Failed to load CSS from ${n}`)),document.head.appendChild(i)}))}removeDDVcss(){const e=document.getElementById(Q);e&&e.remove()}async initializeDDV(){await s.DDV.Core.loadWasm(),await s.DDV.Core.init(),s.DDV.setProcessingHandler("imageFilter",new s.DDV.ImageFilter)}initializeMWCViews(){const{Library:e,Document:n,Page:t,Transfer:i,History:a}=k;this.mwcViews[e].instance=new $(this.mwcViews[e].config),this.mwcViews[n].instance=new F(this.mwcViews[n].config),this.mwcViews[t].instance=new z(this.mwcViews[t].config),this.mwcViews[i].instance=new U(this.mwcViews[i].config),this.mwcViews[a].instance=new J(this.mwcViews[a].config),this.mwcViews[e].instance.initialize(),this.mwcViews[n].instance.initialize(),this.mwcViews[t].instance.initialize(),this.mwcViews[i].instance.initialize(),this.mwcViews[a].instance.initialize()}switchView(e,n){var t,i,a,o,l,s,c;if("none"===(null===(t=this.config.container)||void 0===t?void 0:t.style.display)&&(this.config.container.style.display="block"),e===this.currentView)return void(null===(a=null===(i=this.mwcViews[e].instance)||void 0===i?void 0:i.setVisible)||void 0===a||a.call(i,!0,n));if(this.currentView){null===(l=null===(o=this.mwcViews[this.currentView].instance)||void 0===o?void 0:o.setVisible)||void 0===l||l.call(o,!1,n)}null===(c=null===(s=this.mwcViews[e].instance)||void 0===s?void 0:s.setVisible)||void 0===c||c.call(s,!0,n),this.currentView=e}async processScanResult(e){var n;const t=[];try{if(Array.isArray(e)){const n=e.map((async e=>{var n;const i=null==e?void 0:e._imageData;if((null==i?void 0:i.toBlob)&&(null===(n=null==e?void 0:e.status)||void 0===n?void 0:n.code)===c.EnumResultStatus.RS_SUCCESS){const e=await i.toBlob("image/png");t.push(e)}}));await Promise.all(n)}else if(((null==e?void 0:e.correctedImageResult)||(null==e?void 0:e.imageData))&&(null===(n=null==e?void 0:e.status)||void 0===n?void 0:n.code)===c.EnumResultStatus.RS_SUCCESS){const n=(null==e?void 0:e.correctedImageResult)||(null==e?void 0:e._imageData);if(null==n?void 0:n.toBlob){const e=await n.toBlob("image/png");t.push(e)}}else if(e&&"object"==typeof e&&((i=e)&&0!==Object.keys(i).length)){const n=Object.values(e).map((async e=>{var n;const i=null==e?void 0:e._imageData;if((null==i?void 0:i.toBlob)&&(null===(n=null==e?void 0:e.status)||void 0===n?void 0:n.code)===c.EnumResultStatus.RS_SUCCESS){const e=await i.toBlob("image/png");t.push(e)}}));await Promise.all(n)}}catch(e){let n=`Error processing scan result: ${(null==e?void 0:e.message)||e}`;throw console.error(n),new Error(n)}var i;return t}async handleCameraCapture(e){var n,t,i,a;null===(t=null===(n=this.mwcViews[this.currentView].instance)||void 0===n?void 0:n.setVisible)||void 0===t||t.call(n,!1);try{const n=await this.scanner.launch(),t=await this.processScanResult(n);if(0===t.length)return;if(e===k.Library){const e=t.map((e=>({convertMode:"cm/auto",fileData:e}))),n=await this.mwcViews.library.instance.createAndLoadDocument(`Doc-${Date.now()}`,e);this.handleDocumentClick(n.uid)}else if(e===k.Document||e===k.Page){const e=this.mwcViews[k.Document].instance.browseViewer.currentDocument,n=t.map((e=>({convertMode:"cm/auto",fileData:e})));e&&await e.loadSource(n)}}catch(e){throw console.error("Camera capture failed:",e),new Error(e)}finally{null===(a=null===(i=this.mwcViews[this.currentView].instance)||void 0===i?void 0:i.setVisible)||void 0===a||a.call(i,!0)}}async handleGalleryImport(e){const n=document.createElement("input");n.type="file",n.accept="image/png,image/jpeg,image/bmp,image/tiff,application/pdf",n.multiple=!0,n.onchange=async()=>{var t;const i=Array.from(n.files||[]),a=i.length,o=[];for(let e=0;e<a;e++)o.push({convertMode:"cm/auto",fileData:new Blob([i[e]],{type:i[e].type}),renderOptions:{renderAnnotations:"loadAnnotations"}});if(o.length>0)if(e===k.Library){const e=C(null===(t=i[0])||void 0===t?void 0:t.name),n=await this.mwcViews.library.instance.createAndLoadDocument(e,o);this.handleDocumentClick(n.uid)}else if(e===k.Document||e===k.Page){const n=this.mwcViews[k.Document].instance.browseViewer.currentDocument;n&&(await n.loadSource(o),this.switchView(e))}},n.click()}handleDocumentClick(e){this.mwcViews[k.Document].instance.browseViewer.openDocument(e),this.switchView(k.Document)}handlePageClick(e,n){this.mwcViews[k.Page].instance.openPage(e,n),this.switchView(k.Page)}handleTransferPage(e,n,t){this.switchView(k.Transfer,{mode:e,docId:n,selectedIdx:t})}async handleTransferPageConfirm(e){this.mwcViews.document.instance.handleSelectedBack(),await A(this.mwcViews.document.config.container,"copy"===e?"Pasted":"move"===e?"Moved":"")}handleTransferPageCancel(){this.switchView(k.Document)}handleHistoryBack(e){this.switchView(e)}getUploadedDocuments(){return this.uploadedFiles}dispose(){var e,n;return Object.values(this.mwcViews).forEach((e=>{var n;(null===(n=e.instance)||void 0===n?void 0:n.dispose)&&e.instance.dispose()})),this.scanner.dispose(),s.DDV.documentManager.deleteAllDocuments(),this.config.container instanceof HTMLElement&&(this.config.container.textContent=""),this.isUsingDefaultContainer&&y(this.config.container).remove(),this.removeDDVcss(),this.currentView=null,this.uploadedFiles=[],this.mwcViews=null,this.scanner=null,this.isInitialized=!1,(null===(e=this.config)||void 0===e?void 0:e.onClose)&&(null===(n=this.config)||void 0===n||n.onClose()),this.hasLaunched=!1,Promise.resolve()}}const te={MobileWebCapture:ne,LibraryView:$,DocumentView:F,PageView:z,TransferView:U};e.Core=r,e.License=h,e.CVR=m,e.DCE=u,e.DDN=p,e.Utility=v,e.DDV=w,e.DDS=g,e.DocumentView=F,e.LibraryView=$,e.MWC=te,e.MobileWebCapture=ne,e.PageView=z,e.TransferView=U}));
